/**
 * @license
 * Copyright 2020 Google LLC. All Rights Reserved.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * =============================================================================
 */
!function(e,t){"object"==typeof exports&&"undefined"!=typeof module?t(exports,require("@tensorflow/tfjs-core"),require("seedrandom")):"function"==typeof define&&define.amd?define(["exports","@tensorflow/tfjs-core","seedrandom"],t):t((e=e||self).tf=e.tf||{},e.tf,e.seedrandom)}(this,(function(e,t,a){"use strict";var r=function(e,t){return(r=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var a in t)t.hasOwnProperty(a)&&(e[a]=t[a])})(e,t)};function n(e,t,a,r){return new(a||(a=Promise))((function(n,i){function o(e){try{d(r.next(e))}catch(e){i(e)}}function s(e){try{d(r.throw(e))}catch(e){i(e)}}function d(e){var t;e.done?n(e.value):(t=e.value,t instanceof a?t:new a((function(e){e(t)}))).then(o,s)}d((r=r.apply(e,t||[])).next())}))}function i(e,t){var a,r,n,i,o={label:0,sent:function(){if(1&n[0])throw n[1];return n[1]},trys:[],ops:[]};return i={next:s(0),throw:s(1),return:s(2)},"function"==typeof Symbol&&(i[Symbol.iterator]=function(){return this}),i;function s(i){return function(s){return function(i){if(a)throw new TypeError("Generator is already executing.");for(;o;)try{if(a=1,r&&(n=2&i[0]?r.return:i[0]?r.throw||((n=r.return)&&n.call(r),0):r.next)&&!(n=n.call(r,i[1])).done)return n;switch(r=0,n&&(i=[2&i[0],n.value]),i[0]){case 0:case 1:n=i;break;case 4:return o.label++,{value:i[1],done:!1};case 5:o.label++,r=i[1],i=[0];continue;case 7:i=o.ops.pop(),o.trys.pop();continue;default:if(!(n=o.trys,(n=n.length>0&&n[n.length-1])||6!==i[0]&&2!==i[0])){o=0;continue}if(3===i[0]&&(!n||i[1]>n[0]&&i[1]<n[3])){o.label=i[1];break}if(6===i[0]&&o.label<n[1]){o.label=n[1],n=i;break}if(n&&o.label<n[2]){o.label=n[2],o.ops.push(i);break}n[2]&&o.ops.pop(),o.trys.pop();continue}i=t.call(e,o)}catch(e){i=[6,e],r=0}finally{a=n=0}if(5&i[0])throw i[1];return{value:i[0]?i[1]:void 0,done:!0}}([i,s])}}}function o(e,a){Array.isArray(e)||(e=[e]),e.forEach((function(e){null!=e&&t.util.assert("complex64"!==e.dtype,(function(){return a+" does not support complex64 tensors in the CPU backend."}))}))}var s=t.kernel_impls.nonMaxSuppressionV3Impl,d=t.kernel_impls.split,u=t.kernel_impls.tile,p=t.kernel_impls.topkImpl,l=t.kernel_impls.whereImpl;function f(e,a,r,n){if("linear"===r)return e.linear(a);if("relu"===r)return e.relu(a);if("elu"===r)return t.elu(a);if("relu6"===r)return e.relu6(a);if("prelu"===r)return e.prelu(a,n);throw new Error("Activation "+r+" has not been implemented for the CPU backend.")}var c=function(e){function c(){var a=e.call(this)||this;return a.blockSize=48,a.firstUse=!0,a.data=new t.DataStorage(a,t.engine()),a}return function(e,t){function a(){this.constructor=e}r(e,t),e.prototype=null===t?Object.create(t):(a.prototype=t.prototype,new a)}(c,e),c.prototype.write=function(e,a,r){this.firstUse&&(this.firstUse=!1,t.env().get("IS_NODE")&&t.backend_util.warn("\n============================\nHi there 👋. Looks like you are running TensorFlow.js in Node.js. To speed things up dramatically, install our node backend, which binds to TensorFlow C++, by running npm i @tensorflow/tfjs-node, or npm i @tensorflow/tfjs-node-gpu if you have CUDA. Then call require('@tensorflow/tfjs-node'); (-gpu suffix for CUDA) at the start of your program. Visit https://github.com/tensorflow/tfjs-node for more details.\n============================"));var n={};return this.data.set(n,{values:e,dtype:r,refCount:1}),n},c.prototype.makeTensorInfo=function(e,t,a){return{dataId:this.write(a,e,t),shape:e,dtype:t}},c.prototype.incRef=function(e){this.data.get(e).refCount++},c.prototype.decRef=function(e){this.data.has(e)&&this.data.get(e).refCount--},c.prototype.move=function(e,t,a,r){this.data.set(e,{values:t,dtype:r,refCount:1})},c.prototype.numDataIds=function(){return this.data.numDataIds()},c.prototype.read=function(e){return n(this,void 0,void 0,(function(){return i(this,(function(t){return[2,this.readSync(e)]}))}))},c.prototype.readSync=function(e){var a=this.data.get(e),r=a.dtype,n=a.complexTensorInfos;if("complex64"===r){var i=this.readSync(n.real.dataId),o=this.readSync(n.imag.dataId);return t.backend_util.mergeRealAndImagArrays(i,o)}return this.data.get(e).values},c.prototype.bufferSync=function(e){var a=this.readSync(e.dataId),r=a;if("string"===e.dtype)try{r=a.map((function(e){return t.util.decodeString(e)}))}catch(e){throw new Error("Failed to decode encoded string bytes into utf-8")}return t.buffer(e.shape,e.dtype,r)},c.prototype.makeOutput=function(e,a,r){var n=this.write(e,a,r);return t.engine().makeTensorFromDataId(n,a,r,this)},c.prototype.disposeData=function(e){if(this.data.has(e)){var t=this.data.get(e).complexTensorInfos;null!=t&&(this.disposeData(t.real.dataId),this.disposeData(t.imag.dataId)),this.data.delete(e)}},c.prototype.disposeIntermediateTensorInfo=function(e){var t=e.dataId;if(this.data.has(t)){var a=this.data.get(t);a.refCount--,a.refCount<1&&this.disposeData(t)}},c.prototype.time=function(e){return n(this,void 0,void 0,(function(){var a;return i(this,(function(r){return a=t.util.now(),e(),[2,{kernelMs:t.util.now()-a}]}))}))},c.prototype.memory=function(){return{unreliable:!0,reasons:["The reported memory is an upper bound. Due to automatic garbage collection, the true allocated memory may be less."]}},c.prototype.stridedSlice=function(e,a,r,n){o(e,"stridedSlice");var i=t.slice_util.computeOutShape(a,r,n);if(i.some((function(e){return 0===e})))return t.tensor([],i);for(var s=t.buffer(i,e.dtype),d=this.bufferSync(e),u=0;u<s.size;u++){for(var p=s.indexToLoc(u),l=new Array(p.length),f=0;f<l.length;f++)l[f]=p[f]*n[f]+a[f];s.set.apply(s,[d.get.apply(d,l)].concat(p))}return s.toTensor()},c.prototype.diag=function(e){for(var a=this.readSync(e.dataId),r=t.buffer([e.size,e.size],e.dtype),n=r.values,i=0;i<a.length;i++)n[i*e.size+i]=a[i];return r.toTensor()},c.prototype.unstack=function(e,a){for(var r=e.shape[a],n=new Array(e.rank-1),i=0,o=0;o<e.rank;o++)o!==a&&(n[i++]=e.shape[o]);var s=new Array(e.rank).fill(0),d=e.shape.slice();d[a]=1;var u=new Array(r);for(o=0;o<u.length;o++)s[a]=o,u[o]=t.slice(e,s,d).reshape(n);return u},c.prototype.reverse=function(e,a){o(e,"reverse");for(var r=t.buffer(e.shape,e.dtype),n=this.bufferSync(e),i=function(t){var i=r.indexToLoc(t),o=i.slice();a.forEach((function(t){return o[t]=e.shape[t]-1-o[t]})),r.set.apply(r,[n.get.apply(n,o)].concat(i))},s=0;s<r.size;s++)i(s);return r.toTensor()},c.prototype.neg=function(e){return o(e,"neg"),t.mul(t.scalar(-1),e)},c.prototype.addN=function(e){var a=this;o(e,"addN");for(var r=e.map((function(e){return a.readSync(e.dataId)})),n=t.buffer(e[0].shape,e[0].dtype),i=n.values,s=0;s<e.length;s++)for(var d=r[s],u=0;u<i.length;u++)i[u]+=d[u];return n.toTensor()},c.prototype.softmax=function(e,a){var r=t.util.parseAxisParam([a],e.shape),n=t.max(e,r),i=t.backend_util.expandShapeToKeepDim(n.shape,r),o=t.sub(e,n.reshape(i)),s=t.exp(o),d=this.sum(s,r).reshape(i);return t.div(s,d)},c.prototype.pow=function(e,t){return o([e,t],"pow"),this.broadcastedBinaryOp(e,t,e.dtype,(function(e,t){return Math.pow(e,t)}))},c.prototype.batchMatMul=function(e,a,r,n){o([e,a],"matMul");for(var i=r?e.shape[1]:e.shape[2],s=r?e.shape[2]:e.shape[1],d=n?a.shape[1]:a.shape[2],u=e.shape[0],p=this.readSync(e.dataId),l=this.readSync(a.dataId),f=r?[e.strides[0],1,e.strides[1]]:[e.strides[0],e.strides[1],1],c=f[0],h=f[1],m=f[2],v=n?[1,a.strides[1],a.strides[0]]:[a.strides[1],1,a.strides[0]],y=v[0],k=v[1],g=v[2],I=s*d,b=t.buffer([u,s,d],e.dtype),S=b.values,T=this.blockSize,N=0;N<u;N++)for(var x=0;x<s;x+=T)for(var M=0;M<d;M+=T)for(var F=0;F<i;F+=T)for(var A=Math.min(x+T,s),D=Math.min(M+T,d),_=Math.min(F+T,i),z=x;z<A;z++)for(var W=M;W<D;W++){for(var H=0,w=F;w<_;w++)H+=p[N*c+z*h+w*m]*l[w*y+W*k+N*g];S[N*I+(z*d+W)]+=H}return b.toTensor()},c.prototype.fusedBatchMatMul=function(e){var a=e.a,r=e.b,n=e.transposeA,i=e.transposeB,o=e.bias,s=e.activation,d=e.preluActivationWeights,u=this.batchMatMul(a,r,n,i);return o&&(u=t.add(u,o)),s&&(u=f(this,u,s,d)),u},c.prototype.floorDiv=function(e,t){o([e,t],"floorDiv");return this.broadcastedBinaryOp(e,t,"int32",(function(e,t){return Math.floor(e/t)}))},c.prototype.sum=function(e,a){o(e,"sum"),t.backend_util.assertAxesAreInnerMostDims("sum",a,e.rank);for(var r=t.backend_util.computeOutAndReduceShapes(e.shape,a),n=r[0],i=r[1],s=t.upcastType(e.dtype,"int32"),d=t.zeros(n,s),u=t.util.sizeFromShape(i),p=this.readSync(d.dataId),l=this.readSync(e.dataId),f=0;f<p.length;++f){for(var c=f*u,h=0,m=0;m<u;++m)h+=l[c+m];p[f]=h}return d},c.prototype.prod=function(e,a){o(e,"sum");for(var r=t.backend_util.computeOutAndReduceShapes(e.shape,a),n=r[0],i=r[1],s=t.upcastType(e.dtype,"int32"),d=t.zeros(n,s),u=t.util.sizeFromShape(i),p=this.readSync(d.dataId),l=this.readSync(e.dataId),f=0;f<p.length;++f){for(var c=f*u,h=1,m=0;m<u;++m)h*=l[c+m];p[f]=h}return d},c.prototype.unsortedSegmentSum=function(e,a,r){o(e,"unsortedSegmentSum");for(var n=[],i=e.rank-a.rank,s=0;s<i;++s)a=a.expandDims(s+1);for(s=0;s<r;++s){var d=t.scalar(s,"int32"),u=t.equal(d,a).asType("float32").mul(e).sum(0);n.push(u)}return t.stack(n)},c.prototype.argMin=function(e,a){o(e,"argMin");var r=[a];t.backend_util.assertAxesAreInnerMostDims("argMin",r,e.rank);for(var n=t.backend_util.computeOutAndReduceShapes(e.shape,r),i=n[0],s=n[1],d=t.zeros(i,"int32"),u=t.util.sizeFromShape(s),p=this.readSync(d.dataId),l=this.readSync(e.dataId),f=0;f<p.length;++f){for(var c=f*u,h=l[c],m=0,v=0;v<u;++v){var y=l[c+v];y<h&&(h=y,m=v)}p[f]=m}return d},c.prototype.argMax=function(e,a){o(e,"argMax");var r=[a];t.backend_util.assertAxesAreInnerMostDims("argMax",r,e.rank);for(var n=t.backend_util.computeOutAndReduceShapes(e.shape,r),i=n[0],s=n[1],d=t.zeros(i,"int32"),u=t.util.sizeFromShape(s),p=this.readSync(d.dataId),l=this.readSync(e.dataId),f=0;f<p.length;++f){for(var c=f*u,h=l[c],m=0,v=0;v<u;++v){var y=l[c+v];y>h&&(h=y,m=v)}p[f]=m}return d},c.prototype.cumsum=function(e,a,r,n){if(o(e,"cumsum"),a!==e.rank-1)throw new Error("backend.cumsum in CPU expects an inner-most axis="+(e.rank-1)+" but got axis="+a);for(var i=t.upcastType(e.dtype,"int32"),s=t.zeros(e.shape,i),d=this.readSync(s.dataId),u=this.readSync(e.dataId),p=e.shape[e.rank-1],l=n?function(e,t){return e+p-t-1}:function(e,t){return e+t},f=0;f<u.length;f+=p)for(var c=0;c<p;c++){var h=l(f,c);if(0===c)d[h]=r?0:u[h];else{var m=l(f,c-1);d[h]=r?u[m]+d[m]:u[h]+d[m]}}return s},c.prototype.equal=function(e,t){return o([e,t],"equal"),this.broadcastedBinaryOp(e,t,"bool",(function(e,t){return e===t?1:0}))},c.prototype.notEqual=function(e,t){return o([e,t],"notEqual"),this.broadcastedBinaryOp(e,t,"bool",(function(e,t){return e!==t?1:0}))},c.prototype.less=function(e,t){return o([e,t],"less"),this.broadcastedBinaryOp(e,t,"bool",(function(e,t){return e<t?1:0}))},c.prototype.lessEqual=function(e,t){return o([e,t],"lessEqual"),this.broadcastedBinaryOp(e,t,"bool",(function(e,t){return e<=t?1:0}))},c.prototype.greater=function(e,t){return o([e,t],"greater"),this.broadcastedBinaryOp(e,t,"bool",(function(e,t){return e>t?1:0}))},c.prototype.greaterEqual=function(e,t){return o([e,t],"greaterEqual"),this.broadcastedBinaryOp(e,t,"bool",(function(e,t){return e>=t?1:0}))},c.prototype.logicalAnd=function(e,t){return o([e,t],"logicalAnd"),this.broadcastedBinaryOp(e,t,"bool",(function(e,t){return e&&t}))},c.prototype.logicalOr=function(e,t){return o([e,t],"logicalOr"),this.broadcastedBinaryOp(e,t,"bool",(function(e,t){return e||t}))},c.prototype.select=function(e,a,r){o([e,a,r],"select");for(var n=this.readSync(e.dataId),i=this.readSync(a.dataId),s=this.readSync(r.dataId),d=t.zeros(a.shape,t.upcastType(a.dtype,r.dtype)),u=this.readSync(d.dataId),p=0,l=0===e.rank||e.rank>1||1===a.rank?1:t.util.sizeFromShape(a.shape.slice(1)),f=0;f<n.length;f++)for(var c=0;c<l;c++)1===n[f]?u[p++]=i[f]:u[p++]=s[f];return d},c.prototype.where=function(e){o([e],"where");var t=this.readSync(e.dataId);return l(e.shape,t)},c.prototype.topk=function(e,t,a){o(e,"topk");var r=this.readSync(e.dataId);return p(r,e.shape,e.dtype,t,a)},c.prototype.min=function(e,a){o(e,"min"),t.backend_util.assertAxesAreInnerMostDims("min",a,e.rank);for(var r=t.backend_util.computeOutAndReduceShapes(e.shape,a),n=r[0],i=r[1],s=t.zeros(n,e.dtype),d=t.util.sizeFromShape(i),u=this.readSync(s.dataId),p=this.readSync(e.dataId),l=0;l<u.length;++l){for(var f=l*d,c=p[f],h=0;h<d;++h){var m=p[f+h];m<c&&(c=m)}u[l]=c}return s},c.prototype.minimum=function(e,t){return o([e,t],"minimum"),this.broadcastedBinaryOp(e,t,e.dtype,(function(e,t){return Math.min(e,t)}))},c.prototype.mod=function(e,t){return o([e,t],"mod"),this.broadcastedBinaryOp(e,t,e.dtype,(function(e,t){var a=e%t;return e<0&&t<0||e>=0&&t>=0?a:(a+t)%t}))},c.prototype.maximum=function(e,t){return o([e,t],"maximum"),this.broadcastedBinaryOp(e,t,e.dtype,(function(e,t){return Math.max(e,t)}))},c.prototype.all=function(e,a){o(e,"all"),t.backend_util.assertAxesAreInnerMostDims("all",a,e.rank);for(var r=t.backend_util.computeOutAndReduceShapes(e.shape,a),n=r[0],i=r[1],s=t.zeros(n,e.dtype),d=t.util.sizeFromShape(i),u=this.readSync(s.dataId),p=this.readSync(e.dataId),l=0;l<u.length;++l){for(var f=l*d,c=p[f],h=0;h<d;++h){var m=p[f+h];c=c&&m}u[l]=c}return s},c.prototype.any=function(e,a){o(e,"any"),t.backend_util.assertAxesAreInnerMostDims("any",a,e.rank);for(var r=t.backend_util.computeOutAndReduceShapes(e.shape,a),n=r[0],i=r[1],s=t.zeros(n,e.dtype),d=t.util.sizeFromShape(i),u=this.readSync(s.dataId),p=this.readSync(e.dataId),l=0;l<u.length;++l){for(var f=l*d,c=p[f],h=0;h<d;++h){var m=p[f+h];c=c||m}u[l]=c}return s},c.prototype.squaredDifference=function(e,t){return o([e,t],"squaredDifference"),this.broadcastedBinaryOp(e,t,e.dtype,(function(e,t){var a=e-t;return a*a}))},c.prototype.linear=function(e){return e},c.prototype.relu=function(e){o(e,"relu");for(var a=t.zeros(e.shape,e.dtype),r=this.readSync(a.dataId),n=this.readSync(e.dataId),i=0;i<n.length;++i)r[i]=Math.max(0,n[i]);return a},c.prototype.relu6=function(e){o(e,"relu");for(var a=t.zeros(e.shape,e.dtype),r=this.readSync(a.dataId),n=this.readSync(e.dataId),i=0;i<n.length;++i)r[i]=Math.min(Math.max(0,n[i]),6);return a},c.prototype.prelu=function(e,t){return o([e,t],"prelu"),this.broadcastedBinaryOp(e,t,e.dtype,(function(e,t){return e<0?t*e:e}))},c.prototype.eluDer=function(e,t){o([e,t],"eluDer");for(var a=new Float32Array(t.size),r=this.readSync(t.dataId),n=this.readSync(e.dataId),i=0;i<r.length;++i){var s=r[i];a[i]=s>=1?n[i]:n[i]*(s+1)}return this.makeOutput(a,t.shape,"float32")},c.prototype.atan2=function(e,t){return o([e,t],"atan2"),this.broadcastedBinaryOp(e,t,e.dtype,(function(e,t){return Math.atan2(e,t)}))},c.prototype.fusedConv2d=function(e){var a=e.input,r=e.filter,n=e.convInfo,i=e.bias,o=e.activation,s=e.preluActivationWeights,d=this.conv2d(a,r,n);return i&&(d=t.add(d,i)),o&&(d=f(this,d,o,s)),d},c.prototype.conv2d=function(e,a,r){o([e,a],"conv2d");for(var n=r.filterHeight,i=r.filterWidth,s=r.dilationHeight,d=r.dilationWidth,u=r.padInfo.left,p=r.padInfo.top,l="channelsLast"===r.dataFormat,f=t.buffer(r.outShape,e.dtype),c=e.strides[0],h=l?e.strides[1]:e.strides[2],m=l?e.strides[2]:1,v=l?1:e.strides[1],y=f.strides[0],k=l?f.strides[1]:f.strides[2],g=l?f.strides[2]:1,I=l?1:f.strides[1],b=this.readSync(e.dataId),S=this.readSync(a.dataId),T=f.values,N=0;N<r.batchSize;++N)for(var x=N*c,M=N*y,F=0;F<r.outHeight;++F)for(var A=M+F*k,D=F*r.strideHeight-p,_=0;_<n;_++){var z=D+_*s;if(!(z<0||z>=r.inHeight))for(var W=_*a.strides[0],H=x+z*h,w=0;w<r.outWidth;++w)for(var C=A+w*g,E=w*r.strideWidth-u,B=0;B<i;B++){var P=E+B*d;if(!(P<0||P>=r.inWidth))for(var O=H+P*m,R=W+B*a.strides[1],q=0;q<r.inChannels;++q){for(var L=b[O+q*v],V=0;V<r.outChannels;++V)T[C+V*I]+=L*S[R+V];R+=r.outChannels}}}return f.toTensor()},c.prototype.conv3d=function(e,a,r){for(var n=r.filterDepth,i=r.filterHeight,o=r.filterWidth,s=r.dilationDepth,d=r.dilationHeight,u=r.dilationWidth,p=r.padInfo.front,l=r.padInfo.left,f=r.padInfo.top,c=t.buffer(r.outShape,e.dtype),h=this.readSync(e.dataId),m=this.readSync(a.dataId),v=c.values,y=0;y<r.batchSize;++y)for(var k=y*e.strides[0],g=y*c.strides[0],I=0;I<r.outDepth;++I)for(var b=g+I*c.strides[1],S=I*r.strideDepth-p,T=0;T<n;T++){var N=S+T*s;if(!(N<0||N>=r.inDepth))for(var x=T*a.strides[0],M=k+N*e.strides[1],F=0;F<r.outHeight;++F)for(var A=b+F*c.strides[2],D=F*r.strideHeight-f,_=0;_<i;_++){var z=D+_*d;if(!(z<0||z>=r.inHeight))for(var W=x+_*a.strides[1],H=M+z*e.strides[2],w=0;w<r.outWidth;++w)for(var C=A+w*r.outChannels,E=w*r.strideWidth-l,B=0;B<o;B++){var P=E+B*u;if(!(P<0||P>=r.inWidth))for(var O=W+B*a.strides[2],R=H+P*r.inChannels,q=O,L=0;L<r.inChannels;++L){for(var V=h[R+L],G=0;G<r.outChannels;++G)v[C+G]+=V*m[q+G];q+=r.outChannels}}}}return c.toTensor()},c.prototype.conv2dDerInput=function(e,a,r){o([e,a],"conv2dDerInput");for(var n=t.buffer(r.inShape,"float32"),i=n.values,s=this.readSync(e.dataId),d=this.readSync(a.dataId),u=a.strides,p=u[0],l=u[1],f=u[2],c=r.batchSize,h=r.filterHeight,m=r.filterWidth,v=r.inChannels,y=r.inHeight,k=r.inWidth,g=r.outChannels,I=r.outHeight,b=r.outWidth,S=r.strideHeight,T=r.strideWidth,N=r.dataFormat,x=h-1-r.padInfo.top,M=m-1-r.padInfo.left,F="channelsLast"===N,A=n.strides[0],D=F?n.strides[1]:n.strides[2],_=F?n.strides[2]:1,z=F?1:n.strides[1],W=e.strides[0],H=F?e.strides[1]:e.strides[2],w=F?e.strides[2]:1,C=F?1:e.strides[1],E=0;E<c;++E)for(var B=0;B<v;++B)for(var P=0;P<y;++P)for(var O=P-x,R=Math.max(0,Math.ceil(O/S)),q=Math.min(I,(h+O)/S),L=0;L<k;++L){for(var V=L-M,G=Math.max(0,Math.ceil(V/T)),U=Math.min(b,(m+V)/T),j=0,Y=R;Y<q;++Y)for(var K=Y*S-O,Z=G;Z<U;++Z)for(var J=W*E+H*Y+w*Z,Q=p*(h-1-K)+l*(m-1-(Z*T-V))+f*B,X=0;X<g;++X){j+=s[J+C*X]*d[Q+X]}i[A*E+D*P+_*L+z*B]=j}return n.toTensor()},c.prototype.conv3dDerInput=function(e,a,r){for(var n=t.buffer(r.inShape,"float32"),i=n.values,o=n.strides,s=o[0],d=o[1],u=o[2],p=o[3],l=this.readSync(e.dataId),f=e.strides,c=f[0],h=f[1],m=f[2],v=f[3],y=this.readSync(a.dataId),k=a.strides,g=k[0],I=k[1],b=k[2],S=k[3],T=r.batchSize,N=r.filterDepth,x=r.filterHeight,M=r.filterWidth,F=r.inChannels,A=r.inDepth,D=r.inHeight,_=r.inWidth,z=r.outChannels,W=r.outDepth,H=r.outHeight,w=r.outWidth,C=r.strideDepth,E=r.strideHeight,B=r.strideWidth,P=N-1-r.padInfo.front,O=x-1-r.padInfo.top,R=M-1-r.padInfo.left,q=0;q<T;++q)for(var L=0;L<F;++L)for(var V=0;V<A;++V)for(var G=V-P,U=Math.max(0,Math.ceil(G/C)),j=Math.min(W,(N+G)/C),Y=0;Y<D;++Y)for(var K=Y-O,Z=Math.max(0,Math.ceil(K/E)),J=Math.min(H,(x+K)/E),Q=0;Q<_;++Q){for(var X=Q-R,$=Math.max(0,Math.ceil(X/B)),ee=Math.min(w,(M+X)/B),te=0,ae=U;ae<j;++ae)for(var re=ae*C-G,ne=Z;ne<J;++ne)for(var ie=ne*E-K,oe=$;oe<ee;++oe)for(var se=c*q+h*ae+m*ne+v*oe,de=g*(N-1-re)+I*(x-1-ie)+b*(M-1-(oe*B-X))+S*L,ue=0;ue<z;++ue){te+=l[se+ue]*y[de+ue]}i[s*q+d*V+u*Y+p*Q+L]=te}return n.toTensor()},c.prototype.conv2dDerFilter=function(e,a,r){o([e,a],"conv2dDerFilter");for(var n=r.strideHeight,i=r.strideWidth,s=r.filterHeight,d=r.filterWidth,u="channelsLast"===r.dataFormat,p=t.buffer(r.filterShape,"float32"),l=r.padInfo.left,f=r.padInfo.top,c=this.bufferSync(e),h=this.bufferSync(a),m=0;m<s;++m)for(var v=Math.max(0,Math.ceil((f-m)/n)),y=Math.min(r.outHeight,(r.inHeight+f-m)/n),k=0;k<d;++k)for(var g=Math.max(0,Math.ceil((l-k)/i)),I=Math.min(r.outWidth,(r.inWidth+l-k)/i),b=0;b<r.inChannels;++b)for(var S=0;S<r.outChannels;++S){for(var T=0,N=0;N<r.batchSize;++N)for(var x=v;x<y;++x)for(var M=m+x*n-f,F=g;F<I;++F){var A=k+F*i-l;T+=u?c.get(N,M,A,b)*h.get(N,x,F,S):c.get(N,b,M,A)*h.get(N,S,x,F)}p.set(T,m,k,b,S)}return p.toTensor()},c.prototype.conv3dDerFilter=function(e,a,r){for(var n=r.strideDepth,i=r.strideHeight,o=r.strideWidth,s=r.filterDepth,d=r.filterHeight,u=r.filterWidth,p=t.buffer(r.filterShape,"float32"),l=p.values,f=p.strides,c=f[0],h=f[1],m=f[2],v=f[3],y=this.readSync(a.dataId),k=a.strides,g=k[0],I=k[1],b=k[2],S=k[3],T=this.readSync(e.dataId),N=e.strides,x=N[0],M=N[1],F=N[2],A=N[3],D=r.padInfo.front,_=r.padInfo.left,z=r.padInfo.top,W=0;W<s;++W)for(var H=Math.max(0,Math.ceil((D-W)/n)),w=Math.min(r.outDepth,(r.inDepth+D-W)/n),C=W*c,E=0;E<d;++E)for(var B=Math.max(0,Math.ceil((z-E)/i)),P=Math.min(r.outHeight,(r.inHeight+z-E)/i),O=E*h+C,R=0;R<u;++R)for(var q=Math.max(0,Math.ceil((_-R)/o)),L=Math.min(r.outWidth,(r.inWidth+_-R)/o),V=R*m+O,G=0;G<r.inChannels;++G)for(var U=G*v+V,j=0;j<r.outChannels;++j){for(var Y=0,K=0;K<r.batchSize;++K)for(var Z=K*x,J=K*g,Q=H;Q<w;++Q)for(var X=(W+Q*n-D)*M+Z,$=Q*I+J,ee=B;ee<P;++ee)for(var te=(E+ee*i-z)*F+X,ae=ee*b+$,re=q;re<L;++re){var ne=re*S+ae;Y+=T[(R+re*o-_)*A+te+G]*y[ne+j]}l[U+j]=Y}return p.toTensor()},c.prototype.fusedDepthwiseConv2D=function(e){var a=e.input,r=e.filter,n=e.convInfo,i=e.bias,o=e.activation,s=e.preluActivationWeights,d=this.depthwiseConv2D(a,r,n);return i&&(d=t.add(d,i)),o&&(d=f(this,d,o,s)),d},c.prototype.depthwiseConv2D=function(e,a,r){o([e,a],"depthwiseConv2D");for(var n=r.filterHeight,i=r.filterWidth,s=r.dilationHeight,d=r.dilationWidth,u=r.padInfo.left,p=r.padInfo.top,l=r.outChannels/r.inChannels,f=t.buffer(r.outShape,e.dtype),c=this.readSync(e.dataId),h=this.readSync(a.dataId),m=f.values,v=0;v<r.batchSize;++v)for(var y=v*e.strides[0],k=v*f.strides[0],g=0;g<r.outHeight;++g)for(var I=k+g*f.strides[1],b=g*r.strideHeight-u,S=0;S<n;++S){var T=b+S*s;if(!(T<0||T>=r.inHeight))for(var N=S*a.strides[0],x=y+T*e.strides[1],M=0;M<r.outWidth;++M)for(var F=I+M*f.strides[2],A=M*r.strideWidth-p,D=0;D<i;++D){var _=A+D*d;if(!(_<0||_>=r.inWidth))for(var z=N+D*a.strides[1],W=x+_*r.inChannels,H=F,w=z,C=0;C<r.inChannels;++C){for(var E=c[W+C],B=0;B<l;++B)m[H+B]+=E*h[w+B];H+=l,w+=l}}}return f.toTensor()},c.prototype.depthwiseConv2DDerInput=function(e,a,r){o([e,a],"depthwiseConv2DDerInput");for(var n=t.buffer(r.inShape,"float32"),i=n.values,s=n.strides,d=s[0],u=s[1],p=s[2],l=this.readSync(e.dataId),f=e.strides,c=f[0],h=f[1],m=f[2],v=this.readSync(a.dataId),y=a.strides,k=y[0],g=y[1],I=y[2],b=r.batchSize,S=r.filterHeight,T=r.filterWidth,N=r.inChannels,x=r.inHeight,M=r.inWidth,F=r.outChannels,A=r.outHeight,D=r.outWidth,_=r.strideHeight,z=r.strideWidth,W=S-1-r.padInfo.top,H=T-1-r.padInfo.left,w=F/N,C=0;C<b;++C)for(var E=0;E<N;++E)for(var B=0;B<x;++B)for(var P=B-W,O=Math.max(0,Math.ceil(P/_)),R=Math.min(A,(S+P)/_),q=0;q<M;++q){for(var L=q-H,V=Math.max(0,Math.ceil(L/z)),G=Math.min(D,(T+L)/z),U=0,j=O;j<R;++j)for(var Y=j*_-P,K=V;K<G;++K)for(var Z=c*C+h*j+m*K,J=k*(S-1-Y)+g*(T-1-(K*z-L))+I*E,Q=0;Q<w;++Q){U+=l[Z+(E*w+Q)]*v[J+Q]}i[d*C+u*B+p*q+E]=U}return n.toTensor()},c.prototype.depthwiseConv2DDerFilter=function(e,a,r){o([e,a],"depthwiseConv2DDerFilter");for(var n=r.strideHeight,i=r.strideWidth,s=r.filterHeight,d=r.filterWidth,u=t.buffer(r.filterShape,"float32"),p=r.padInfo.left,l=r.padInfo.top,f=r.outChannels/r.inChannels,c=this.bufferSync(e),h=this.bufferSync(a),m=0;m<s;++m)for(var v=Math.max(0,Math.ceil((l-m)/n)),y=Math.min(r.outHeight,(r.inHeight+l-m)/n),k=0;k<d;++k)for(var g=Math.max(0,Math.ceil((p-k)/i)),I=Math.min(r.outWidth,(r.inWidth+p-k)/i),b=0;b<r.outChannels;++b){for(var S=Math.trunc(b/f),T=b%f,N=0,x=0;x<r.batchSize;++x)for(var M=v;M<y;++M)for(var F=m+M*n-l,A=g;A<I;++A){var D=k+A*i-p;N+=c.get(x,F,D,S)*h.get(x,M,A,b)}u.set(N,m,k,S,T)}return u.toTensor()},c.prototype.tile=function(e,t){return o(e,"tile"),u(this.bufferSync(e),t)},c.prototype.gather=function(e,a,r){o([e,a],"gather");var n=e.shape.slice(),i=this.readSync(a.dataId);n[r]=i.length;for(var s=t.buffer(n,e.dtype),d=this.bufferSync(e),u=0;u<s.size;++u){var p=s.indexToLoc(u),l=p.slice();l[r]=i[p[r]];var f=d.locToIndex(l);s.values[u]=d.values[f]}return s.toTensor()},c.prototype.batchToSpaceND=function(e,a,r){o([e],"batchToSpaceND");var n=a.reduce((function(e,t){return e*t})),i=t.backend_util.getReshaped(e.shape,a,n),s=t.backend_util.getPermuted(i.length,a.length),d=t.backend_util.getReshapedPermuted(e.shape,a,n),u=t.backend_util.getSliceBeginCoords(r,a.length),p=t.backend_util.getSliceSize(d,r,a.length);return t.transpose(e.reshape(i),s).reshape(d).slice(u,p)},c.prototype.pool3d=function(e,a,r){o(e,"pool3d");for(var n=a.strideDepth,i=a.strideHeight,s=a.strideWidth,d=a.dilationDepth,u=a.dilationHeight,p=a.dilationWidth,l=a.effectiveFilterDepth,f=a.effectiveFilterHeight,c=a.effectiveFilterWidth,h=a.padInfo.front,m=a.padInfo.top,v=a.padInfo.left,y="max"===r?Number.NEGATIVE_INFINITY:Number.POSITIVE_INFINITY,k=this.readSync(e.dataId),g=t.buffer(a.outShape,e.dtype),I=g.values,b=a.outShape[1]*a.outShape[2]*a.outShape[3]*a.outShape[4],S=a.outShape[2]*a.outShape[3]*a.outShape[4],T=a.outShape[3]*a.outShape[4],N=a.outShape[4],x=0;x<a.batchSize;++x)for(var M=x*b,F=x*e.strides[0],A=0;A<a.inChannels;++A)for(var D=0;D<a.outDepth;++D){for(var _=D*n-h,z=_;z<0;)z+=d;for(var W=Math.min(a.inDepth,l+_),H=M+D*S,w=0;w<a.outHeight;++w){for(var C=w*i-m,E=C;E<0;)E+=u;for(var B=Math.min(a.inHeight,f+C),P=H+w*T,O=0;O<a.outWidth;++O){for(var R=O*s-v,q=R;q<0;)q+=p;for(var L=Math.min(a.inWidth,c+R),V=P+O*N,G=y,U=0,j=0,Y=z;Y<W;Y+=d){for(var K=F+Y*e.strides[1],Z=E;Z<B;Z+=u){for(var J=K+Z*e.strides[2],Q=q;Q<L;Q+=p){var X=k[J+Q*e.strides[3]+A];if("max"===r&&X>G?G=X:"avg"===r&&(U+=X,j++),isNaN(G))break}if(isNaN(G))break}if(isNaN(G))break}I[V+A]="avg"===r?U/j:G}}}return g.toTensor()},c.prototype.avgPool3d=function(e,t){return o(e,"avgPool3d"),this.pool3d(e,t,"avg").toFloat()},c.prototype.avgPool3dBackprop=function(e,a,r){o([e,a],"avgPool3dBackprop");for(var n=r.strideDepth,i=r.strideHeight,s=r.strideWidth,d=r.filterDepth,u=r.filterHeight,p=r.filterWidth,l=r.dilationDepth,f=r.dilationHeight,c=r.dilationWidth,h=r.effectiveFilterDepth,m=r.effectiveFilterHeight,v=r.effectiveFilterWidth,y=h-1-r.padInfo.front,k=v-1-r.padInfo.left,g=m-1-r.padInfo.top,I=t.buffer(a.shape,"float32"),b=1/(d*u*p),S=this.bufferSync(e),T=0;T<r.batchSize;++T)for(var N=0;N<r.inChannels;++N)for(var x=0;x<r.inDepth;++x)for(var M=0;M<r.inHeight;++M)for(var F=0;F<r.inWidth;++F){for(var A=x-y,D=M-g,_=F-k,z=0,W=0;W<h;W+=l){var H=(A+W)/n;if(!(H<0||H>=r.outDepth||Math.floor(H)!==H))for(var w=0;w<m;w+=f){var C=(D+w)/i;if(!(C<0||C>=r.outHeight||Math.floor(C)!==C))for(var E=0;E<v;E+=c){var B=(_+E)/s;if(!(B<0||B>=r.outWidth||Math.floor(B)!==B))z+=S.get(T,H,C,B,N)}}}I.set(z*b,T,x,M,F,N)}return I.toTensor()},c.prototype.maxPool3d=function(e,t){return o(e,"maxPool3d"),this.pool3d(e,t,"max").toFloat()},c.prototype.maxPool3dPositions=function(e,a){for(var r=t.buffer(a.outShape,"int32"),n=a.strideDepth,i=a.strideHeight,o=a.strideWidth,s=a.dilationDepth,d=a.dilationHeight,u=a.dilationWidth,p=a.effectiveFilterDepth,l=a.effectiveFilterHeight,f=a.effectiveFilterWidth,c=a.padInfo.front,h=a.padInfo.top,m=a.padInfo.left,v=this.bufferSync(e),y=0;y<a.batchSize;++y)for(var k=0;k<a.inChannels;++k)for(var g=0;g<a.outDepth;++g){for(var I=g*n-c,b=I;b<0;)b+=s;for(var S=Math.min(a.inDepth,p+I),T=0;T<a.outHeight;++T){for(var N=T*i-h,x=N;x<0;)x+=d;for(var M=Math.min(a.inHeight,l+N),F=0;F<a.outWidth;++F){for(var A=F*o-m,D=A;D<0;)D+=u;for(var _=Math.min(a.inWidth,f+A),z=Number.NEGATIVE_INFINITY,W=-1,H=b;H<S;H+=s)for(var w=H-I,C=x;C<M;C+=d)for(var E=C-N,B=D;B<_;B+=u){var P=B-A,O=v.get(y,H,C,B,k);O>=z&&(z=O,W=w*l*f+E*l+P)}r.set(W,y,g,T,F,k)}}}return r.toTensor()},c.prototype.maxPool3dBackprop=function(e,a,r,n){o([a,r],"maxPool3dBackprop");for(var i=this.maxPool3dPositions(a,n),s=n.strideDepth,d=n.strideHeight,u=n.strideWidth,p=n.dilationDepth,l=n.dilationHeight,f=n.dilationWidth,c=n.effectiveFilterDepth,h=n.effectiveFilterHeight,m=n.effectiveFilterWidth,v=c-1-n.padInfo.front,y=m-1-n.padInfo.left,k=h-1-n.padInfo.top,g=t.buffer(a.shape,"float32"),I=this.bufferSync(i),b=this.bufferSync(e),S=0;S<n.batchSize;++S)for(var T=0;T<n.inChannels;++T)for(var N=0;N<n.inDepth;++N)for(var x=0;x<n.inHeight;++x)for(var M=0;M<n.inWidth;++M){for(var F=N-v,A=x-k,D=M-y,_=0,z=0;z<c;z+=p){var W=(F+z)/s;if(!(W<0||W>=n.outDepth||Math.floor(W)!==W))for(var H=0;H<h;H+=l){var w=(A+H)/d;if(!(w<0||w>=n.outHeight||Math.floor(w)!==w))for(var C=0;C<m;C+=f){var E=(D+C)/u;if(!(E<0||E>=n.outWidth||Math.floor(E)!==E)){var B=c*h*m-1-I.get(S,W,w,E,T)===z*h*m+H*m+C?1:0;if(0!==B)_+=b.get(S,W,w,E,T)*B}}}}g.set(_,S,N,x,M,T)}return g.toTensor()},c.prototype.resizeBilinear=function(e,a,r,n){o(e,"resizeBilinear");for(var i=e.shape,s=i[0],d=i[1],u=i[2],p=i[3],l=this.readSync(e.dataId),f=new Float32Array(t.util.sizeFromShape([s,a,r,p])),c=[n&&a>1?d-1:d,n&&r>1?u-1:u],h=[n&&a>1?a-1:a,n&&r>1?r-1:r],m=0,v=c[0]/h[0],y=c[1]/h[1],k=0;k<s;k++)for(var g=0;g<a;g++)for(var I=v*g,b=Math.floor(I),S=I-b,T=Math.min(d-1,Math.ceil(I)),N=k*e.strides[0]+b*e.strides[1],x=k*e.strides[0]+T*e.strides[1],M=0;M<r;M++)for(var F=y*M,A=Math.floor(F),D=F-A,_=Math.min(u-1,Math.ceil(F)),z=N+A*e.strides[2],W=x+A*e.strides[2],H=N+_*e.strides[2],w=x+_*e.strides[2],C=0;C<p;C++){var E=l[z+C],B=l[W+C],P=E+(l[H+C]-E)*D,O=P+(B+(l[w+C]-B)*D-P)*S;f[m++]=O}return t.tensor(f,[s,a,r,p])},c.prototype.resizeBilinearBackprop=function(e,a,r){o([e,a],"resizeBilinearBackprop");for(var n=a.shape,i=n[0],s=n[1],d=n[2],u=n[3],p=e.shape,l=p[1],f=p[2],c=new Float32Array(i*s*d*u),h=[r&&l>1?s-1:s,r&&f>1?d-1:d],m=[r&&l>1?l-1:l,r&&f>1?f-1:f],v=h[0]/m[0],y=h[1]/m[1],k=this.readSync(e.dataId),g=0,I=0;I<i;I++)for(var b=I*a.strides[0],S=0;S<l;S++)for(var T=S*v,N=Math.floor(T),x=Math.min(Math.ceil(T),s-1),M=b+N*a.strides[1],F=b+x*a.strides[1],A=T-N,D=1-A,_=0;_<f;_++)for(var z=_*y,W=Math.floor(z),H=Math.min(Math.ceil(z),d-1),w=z-W,C=1-w,E=M+W*a.strides[2],B=M+H*a.strides[2],P=F+W*a.strides[2],O=F+H*a.strides[2],R=D*C,q=D*w,L=A*C,V=A*w,G=0;G<u;G++){var U=k[g++];c[E+G]+=U*R,c[B+G]+=U*q,c[P+G]+=U*L,c[O+G]+=U*V}return t.tensor4d(c,[i,d,s,u],a.dtype)},c.prototype.resizeNearestNeighbor=function(e,a,r,n){o(e,"resizeNearestNeighbor");for(var i=e.shape,s=i[0],d=i[1],u=i[2],p=i[3],l=this.readSync(e.dataId),f=new Float32Array(s*a*r*p),c=[n&&a>1?d-1:d,n&&r>1?u-1:u],h=[n&&a>1?a-1:a,n&&r>1?r-1:r],m=c[0]/h[0],v=c[1]/h[1],y=0,k=0;k<s;k++)for(var g=k*e.strides[0],I=0;I<a;I++)for(var b=m*I,S=g+Math.min(d-1,n?Math.round(b):Math.floor(b))*e.strides[1],T=0;T<r;T++)for(var N=v*T,x=S+Math.min(u-1,n?Math.round(N):Math.floor(N))*e.strides[2],M=0;M<p;M++){var F=l[x+M];f[y++]=F}return t.tensor(f,[s,a,r,p],e.dtype)},c.prototype.resizeNearestNeighborBackprop=function(e,a,r){o([e,a],"resizeNearestNeighborBackprop");for(var n=a.shape,i=n[0],s=n[1],d=n[2],u=n[3],p=e.shape,l=p[1],f=p[2],c=new Float32Array(i*s*d*u),h=this.readSync(e.dataId),m=[r&&l>1?s-1:s,r&&f>1?d-1:d],v=[r&&l>1?l-1:l,r&&f>1?f-1:f],y=m[0]/v[0],k=m[1]/v[1],g=1/y,I=1/k,b=2*Math.ceil(g)+2,S=2*Math.ceil(I)+2,T=0;T<i;T++)for(var N=T*a.strides[0],x=0;x<s;x++)for(var M=N+x*a.strides[1],F=Math.floor(x*g),A=Math.floor(F-b/2),D=0;D<d;D++)for(var _=M+D*a.strides[2],z=Math.floor(D*I),W=Math.floor(z-S/2),H=0;H<u;H++){for(var w=0,C=0;C<b;C++){var E=C+A;if(!(E<0||E>=l)){var B=N+E*e.strides[1],P=E*y;if(x===Math.min(s-1,r?Math.round(P):Math.floor(P)))for(var O=0;O<S;O++){var R=O+W;if(!(R<0||R>=f)){var q=B+R*e.strides[2],L=R*k;D===Math.min(d-1,r?Math.round(L):Math.floor(L))&&(w+=h[q+H])}}}}c[_+H]=w}return t.tensor4d(c,a.shape,a.dtype)},c.prototype.localResponseNormalization4D=function(e,a,r,n,i){o(e,"localResponseNormalization4D");var s=e.shape[3],d=s-1,u=this.readSync(e.dataId),p=e.size,l=new Float32Array(p);function f(e){for(var t=e%s,r=e-t+Math.max(0,t-a),n=e-t+Math.min(t+a,d),i=0;r<=n;r++){var o=u[r];i+=o*o}return i}for(var c=0;c<p;c++){var h=f(c),m=u[c]*Math.pow(r+n*h,-i);l[c]=m}return t.tensor4d(l,e.shape)},c.prototype.LRNGrad=function(e,a,r,n,i,s,d){o(e,"LRNGrad");for(var u=e.shape[3],p=this.readSync(e.dataId),l=this.readSync(a.dataId),f=this.readSync(r.dataId),c=new Float32Array(e.size),h=e.size,m=0;m<h;m++){for(var v=m%u,y=m-v+Math.max(0,v-n),k=m-v+Math.min(u,v+n+1),g=0,I=y;I<k;I++)g+=Math.pow(l[I],2);g=s*g+i;for(I=y;I<k;I++){var b=-2*s*d*l[I]*f[m]/g;m===I&&(b+=Math.pow(g,-d)),b*=p[m],c[I]+=b}}return t.tensor4d(c,e.shape)},c.prototype.multinomial=function(e,r,n,i){o(e,"multinomial");for(var s=r?e:t.softmax(e),d=s.shape[0],u=s.shape[1],p=t.zeros([d,n],"int32"),l=this.readSync(p.dataId),f=this.readSync(s.dataId),c=0;c<d;++c){var h=c*u,m=new Float32Array(u-1);m[0]=f[h];for(var v=1;v<m.length;++v)m[v]=m[v-1]+f[h+v];for(var y=a.alea(i.toString()),k=c*n,g=0;g<n;++g){var I=y();l[k+g]=m.length;for(var b=0;b<m.length;b++)if(I<m[b]){l[k+g]=b;break}}}return p},c.prototype.oneHot=function(e,a,r,n){o(e,"oneHot");var i=new Float32Array(e.size*a);i.fill(n);for(var s=this.readSync(e.dataId),d=0;d<e.size;++d)s[d]>=0&&s[d]<a&&(i[d*a+s[d]]=r);return t.tensor2d(i,[e.size,a],"int32")},c.prototype.nonMaxSuppression=function(e,t,a,r,n){o(e,"nonMaxSuppression");var i=this.readSync(e.dataId),d=this.readSync(t.dataId);return s(i,d,a,r,n)},c.prototype.depthToSpace=function(e,a,r){t.util.assert("NHWC"===r,(function(){return"Only NHWC dataFormat supported on CPU for depthToSpace. Got "+r})),t.util.assert(a>1,(function(){return"blockSize should be > 1 for depthToSpace, but was: "+a}));for(var n=e.shape[0],i=e.shape[1],o=e.shape[2],s=e.shape[3],d=i*a,u=o*a,p=s/(a*a),l=this.readSync(e.dataId),f=new Float32Array(n*d*u*p),c=0,h=0;h<n;++h)for(var m=0;m<d;++m)for(var v=Math.floor(m/a),y=m%a,k=0;k<u;++k)for(var g=Math.floor(k/a),I=(y*a+k%a)*p,b=0;b<p;++b){var S=b+I+s*(g+o*(v+i*h));f[c++]=l[S]}return t.tensor4d(f,[n,d,u,p])},c.prototype.broadcastedBinaryOp=function(e,a,r,n){var i=t.backend_util.assertAndGetBroadcastShape(e.shape,a.shape),o=t.buffer(i,r),s=this.readSync(e.dataId),d=this.readSync(a.dataId),u=t.backend_util.getBroadcastDims(e.shape,i),p=t.backend_util.getBroadcastDims(a.shape,i),l=o.values;if(u.length+p.length===0)for(var f=0;f<l.length;++f)l[f]=n(s[f%s.length],d[f%d.length]);else{var c=this.bufferSync(e),h=this.bufferSync(a),m=function(t){var r=o.indexToLoc(t),i=r.slice(-e.rank);u.forEach((function(e){return i[e]=0}));var f=c.locToIndex(i),m=r.slice(-a.rank);p.forEach((function(e){return m[e]=0}));var v=h.locToIndex(m);l[t]=n(s[f],d[v])};for(f=0;f<l.length;++f)m(f)}return o.toTensor()},c.prototype.split=function(e,t,a){return d(e,t,a)},c.prototype.dispose=function(){},c.prototype.floatPrecision=function(){return 32},c.prototype.epsilon=function(){return e.prototype.epsilon.call(this)},c.prototype.cropAndResize=function(e,a,r,n,i,o){for(var s=e.shape,d=s[0],u=s[1],p=s[2],l=s[3],f=a.shape[0],c=n[0],h=n[1],m=t.buffer([f,c,h,l],"float32"),v=this.readSync(a.dataId),y=this.readSync(r.dataId),k=this.readSync(e.dataId),g=e.strides,I=m.strides,b=0;b<f;b++){var S=4*b,T=v[S],N=v[S+1],x=v[S+2],M=v[S+3],F=y[b];if(!(F>=d))for(var A=c>1?(x-T)*(u-1)/(c-1):0,D=h>1?(M-N)*(p-1)/(h-1):0,_=0;_<c;_++){var z=c>1?T*(u-1)+_*A:.5*(T+x)*(u-1);if(z<0||z>u-1)for(var W=0;W<h;W++)for(var H=0;H<l;H++){var w=H+W*I[2]+_*I[1]+b*I[0];m.values[w]=o}else if("bilinear"===i){var C=Math.floor(z),E=Math.ceil(z),B=z-C;for(W=0;W<h;W++){if((j=h>1?N*(p-1)+W*D:.5*(N+M)*(p-1))<0||j>p-1)for(H=0;H<l;H++){w=H+W*I[2]+_*I[1]+b*I[0];m.values[w]=o}else{var P=Math.floor(j),O=Math.ceil(j),R=j-P;for(H=0;H<l;H++){var q=k[w=H+P*g[2]+C*g[1]+F*g[0]],L=k[w=H+O*g[2]+C*g[1]+F*g[0]],V=k[w=H+P*g[2]+E*g[1]+F*g[0]],G=q+(L-q)*R,U=V+(k[w=H+O*g[2]+E*g[1]+F*g[0]]-V)*R;w=H+W*I[2]+_*I[1]+b*I[0],m.values[w]=G+(U-G)*B}}}}else for(W=0;W<h;++W){var j;if((j=h>1?N*(p-1)+W*D:.5*(N+M)*(p-1))<0||j>p-1)for(H=0;H<l;H++){w=H+W*I[2]+_*I[1]+b*I[0];m.values[w]=o}else{var Y=Math.round(j),K=Math.round(z);for(H=0;H<l;H++){var Z=H+Y*g[2]+K*g[1]+F*g[0],J=H+W*I[2]+_*I[1]+b*I[0];m.values[J]=k[Z]}}}}}return m.toTensor()},c.prototype.sparseToDense=function(e,a,r,n){var i=t.backend_util.calculateShapes(a,e,r),o=i.sliceRank,s=i.numUpdates,d=i.sliceSize,u=i.strides,p=i.outputSize;return this.scatter(e,a,r,p,d,s,o,u,n,!1)},c.prototype.gatherND=function(e,a){var r=a.shape,n=r[r.length-1],i=t.backend_util.prepareAndValidate(e,a),o=i[0],s=i[1],d=i[2],u=i[3];if(0===s)return t.tensor([],o,e.dtype);for(var p=new t.TensorBuffer([s,d],e.dtype),l=this.readSync(a.dataId),f=this.readSync(e.dataId),c=0;c<s;c++){for(var h=[],m=0,v=0;v<n;v++){var y=l[c*n+v];m+=y*u[v],h.push(y)}if(m<0||m>=e.size/d)throw new Error("Invalid indices: "+h+" does not index into "+e.shape);for(var k=0;k<d;k++)p.values[c*d+k]=f[m*d+k]}return p.toTensor().reshape(o)},c.prototype.scatterND=function(e,a,r){var n=t.backend_util.calculateShapes(a,e,r),i=n.sliceRank,o=n.numUpdates,s=n.sliceSize,d=n.strides,u=n.outputSize,p=t.scalar(0);return this.scatter(e,a,r,u,s,o,i,d,p,!0)},c.prototype.fill=function(e,a,r){r=r||t.util.inferDtype(a);var n=t.util.getArrayFromDType(r,t.util.sizeFromShape(e));return n.fill(a),t.engine().makeTensor(n,e,r,this)},c.prototype.onesLike=function(e){if("string"===e.dtype)throw new Error("onesLike is not supported for string tensors");return this.fill(e.shape,1,e.dtype)},c.prototype.zerosLike=function(e){var a=t.util.getArrayFromDType(e.dtype,t.util.sizeFromShape(e.shape));return this.makeOutput(a,e.shape,e.dtype)},c.prototype.linspace=function(e,a,r){return t.backend_util.linspaceImpl(e,a,r)},c.prototype.scatter=function(e,a,r,n,i,o,s,d,u,p){var l=[n/i,i],f=this.readSync(e.dataId),c=this.readSync(a.dataId);if(0===n)return t.tensor([],r,a.dtype);var h=new t.TensorBuffer(l,a.dtype);h.values.fill(this.readSync(u.dataId)[0]);for(var m=0;m<o;m++){for(var v=[],y=0,k=0;k<s;k++){var g=f[m*s+k];v.push(g),y+=g*d[k]}if(y<0||y>=n/i)throw new Error("Invalid indices: "+v+" does not index into "+r);for(var I=0;I<i;I++)p?h.values[y*i+I]+=c[m*i+I]:h.values[y*i+I]=0===a.rank?c[0]:c[m*i+I]}return h.toTensor().reshape(r)},c}(t.KernelBackend);function h(e,a,r,n){for(var i=t.util.getTypedArrayFromDType(n,t.util.sizeFromShape(r)),o=0;o<i.length;++o){for(var s=o*a,d=e[s],u=0;u<a;++u){var p=e[s+u];p>d&&(d=p)}i[o]=d}return i}function m(e,a,r,n,i){for(var o=a.length,s=t.util.sizeFromShape(a),d=t.util.computeStrides(a),u=t.util.computeStrides(i),p=t.util.getTypedArrayFromDType(r,t.util.sizeFromShape(i)),l=0;l<s;++l){for(var f=t.util.indexToLoc(l,o,d),c=new Array(f.length),h=0;h<c.length;h++)c[h]=f[n[h]];p[t.util.locToIndex(c,o,u)]=e[l]}return p}var v={__proto__:null,maxImpl:h,transposeImpl:m};t.registerBackend("cpu",(function(){return new c}),1);var y={kernelName:t.Abs,backendName:"cpu",kernelFunc:function(e){var a=e.inputs.x,r=e.backend,n=new Float32Array(t.util.sizeFromShape(a.shape));if("complex64"!==a.dtype)for(var i=r.data.get(a.dataId).values,o=0;o<i.length;++o)n[o]=Math.abs(i[o]);else{var s=r.data.get(a.dataId),d=s.complexTensorInfos.real,u=s.complexTensorInfos.imag,p=r.data.get(d.dataId).values,l=r.data.get(u.dataId).values;for(o=0;o<p.length;o++){var f=p[o],c=l[o];n[o]=Math.hypot(f,c)}}return r.makeOutput(n,a.shape,"float32")}};function k(e,a,r){return function(n){var i=n.inputs,s=n.attrs,d=n.backend,u=i.x;if(o(u,e),"string"===u.dtype||"string"===r)throw new Error("unaryKernelFunc does not support string input/output");for(var p=d,l=p.data.get(u.dataId).values,f=t.util.sizeFromShape(u.shape),c=r||u.dtype,h=t.util.getArrayFromDType(c,f),m=0;m<f;++m)h[m]=a(l[m],s);return p.makeTensorInfo(u.shape,c,h)}}var g=k(t.Acos,(function(e){return Math.acos(e)})),I={kernelName:t.Acos,backendName:"cpu",kernelFunc:g},b=k(t.Acosh,(function(e){return Math.acosh(e)})),S={kernelName:t.Acosh,backendName:"cpu",kernelFunc:b};function T(e){return function(a,r,n,i,o){var s=t.backend_util.assertAndGetBroadcastShape(a,r),d=s.length,u=t.util.computeStrides(s),p=t.util.sizeFromShape(s),l=t.util.getTypedArrayFromDType(o,p),f=a.length,c=r.length,h=t.util.computeStrides(a),m=t.util.computeStrides(r),v=t.backend_util.getBroadcastDims(a,s),y=t.backend_util.getBroadcastDims(r,s);if(v.length+y.length===0)for(var k=0;k<l.length;++k)l[k]=e(n[k%n.length],i[k%i.length]);else{var g=function(a){var r=t.util.indexToLoc(a,d,u),o=r.slice(-f);v.forEach((function(e){return o[e]=0}));var s=t.util.locToIndex(o,f,h),p=r.slice(-c);y.forEach((function(e){return p[e]=0}));var k=t.util.locToIndex(p,c,m);l[a]=e(n[s],i[k])};for(k=0;k<l.length;++k)g(k)}return[l,s]}}function N(e){var t=e.inputs,a=e.backend,r=t.real,n=t.imag,i=a.data.get(r.dataId).values,o=a.data.get(n.dataId).values,s=a.makeTensorInfo(r.shape,"complex64");return a.data.get(s.dataId).complexTensorInfos={real:a.makeTensorInfo(r.shape,"float32",i),imag:a.makeTensorInfo(n.shape,"float32",o)},s}var x={kernelName:t.Complex,backendName:"cpu",kernelFunc:N};function M(e){var t=e.inputs,a=e.backend,r=t.x;return a.incRef(r.dataId),{dataId:r.dataId,shape:r.shape,dtype:r.dtype}}var F={kernelName:t.Identity,backendName:"cpu",kernelFunc:M};function A(e){var t=e.inputs,a=e.backend,r=t.input,n=a.data.get(r.dataId).complexTensorInfos.real,i=a.data.get(n.dataId).values;return a.makeTensorInfo(n.shape,n.dtype,i)}var D={kernelName:t.Real,backendName:"cpu",kernelFunc:A};function _(e){var a=e.inputs,r=e.backend,n=e.attrs,i=a.x,o=n.dtype;if("complex64"===o){if("complex64"===i.dtype)return M({inputs:{x:i},backend:r});var s=t.zeros(i.shape),d=_({inputs:{x:i},backend:r,attrs:{dtype:"float32"}}),u=N({inputs:{real:d,imag:s},backend:r});return s.dispose(),r.disposeIntermediateTensorInfo(d),u}if("complex64"===i.dtype){var p=A({inputs:{input:i},backend:r}),u=_({inputs:{x:p},backend:r,attrs:{dtype:o}});return r.disposeIntermediateTensorInfo(p),u}if(!t.util.hasEncodingLoss(i.dtype,o))return{dataId:(u=M({inputs:{x:i},backend:r})).dataId,shape:u.shape,dtype:o};if("int32"===o){var l=r.data.get(i.dataId).values,f=Int32Array.from(l);return r.makeTensorInfo(i.shape,"int32",f)}if("bool"===o){var c=r.data.get(i.dataId).values,h=t.util.toTypedArray([0],i.dtype),m=T((function(e,t){return e!==t?1:0}))(i.shape,[],c,h,"bool"),v=m[0],y=m[1];return r.makeTensorInfo(y,"bool",v)}throw new Error("Error in Cast: failed to cast "+i.dtype+" to "+o)}var z={kernelName:t.Cast,backendName:"cpu",kernelFunc:_};function W(e,a,r,n){return null==r?function(t){var r=t.inputs,i=t.backend,s=r,d=s.a,u=s.b,p=i;o([d,u],e);var l=p.data.get(d.dataId).values,f=p.data.get(u.dataId).values,c=n||d.dtype,h=T(a)(d.shape,u.shape,l,f,c),m=h[0],v=h[1];return p.makeTensorInfo(v,c,m)}:function(e){var i=e.inputs,o=e.backend,s=i,d=s.a,u=s.b,p=o;if("complex64"===d.dtype||"complex64"===u.dtype){var l=_({inputs:{x:d},backend:p,attrs:{dtype:"complex64"}}),f=p.data.get(l.dataId),c=f.complexTensorInfos.real,h=f.complexTensorInfos.imag,m=p.data.get(c.dataId).values,v=p.data.get(h.dataId).values,y=_({inputs:{x:u},backend:p,attrs:{dtype:"complex64"}}),k=p.data.get(y.dataId),g=k.complexTensorInfos.real,I=k.complexTensorInfos.imag,b=p.data.get(g.dataId).values,S=p.data.get(I.dataId).values,x=function(e){return function(a,r,n,i,o,s){var d=t.backend_util.assertAndGetBroadcastShape(a,r),u=t.util.sizeFromShape(d),p=d.length,l=t.util.computeStrides(d),f=t.util.getTypedArrayFromDType("float32",u),c=t.util.getTypedArrayFromDType("float32",u),h=t.backend_util.getBroadcastDims(a,d),m=t.backend_util.getBroadcastDims(r,d),v=t.backend_util.mergeRealAndImagArrays(n,i),y=t.backend_util.mergeRealAndImagArrays(o,s),k=a.length,g=t.util.computeStrides(a),I=r.length,b=t.util.computeStrides(r);if(h.length+m.length===0)for(var S=0;S<f.length;S++){var T=S%v.length,N=S%y.length,x=e(v[2*T],v[2*T+1],y[2*N],y[2*N+1]);f[S]=x.real,c[S]=x.imag}else{var M=function(a){var r=t.util.indexToLoc(a,p,l),n=r.slice(-k);h.forEach((function(e){return n[e]=0}));var i=t.util.locToIndex(n,k,g),o=r.slice(-I);m.forEach((function(e){return o[e]=0}));var s=t.util.locToIndex(o,I,b),d=e(v[2*i],v[2*i+1],y[2*s],y[2*s+1]);f[a]=d.real,c[a]=d.imag};for(S=0;S<f.length;S++)M(S)}return[f,c,d]}}(r)(d.shape,u.shape,m,v,b,S),M=x[0],F=x[1],A=x[2],D=p.makeTensorInfo(A,"float32",M),z=p.makeTensorInfo(A,"float32",F),W=N({inputs:{real:D,imag:z},backend:p});return p.disposeIntermediateTensorInfo(l),p.disposeIntermediateTensorInfo(y),p.disposeIntermediateTensorInfo(D),p.disposeIntermediateTensorInfo(z),W}var H=p.data.get(d.dataId).values,w=p.data.get(u.dataId).values,C=n||d.dtype,E=T(a)(d.shape,u.shape,H,w,C),B=E[0];A=E[1];return p.makeTensorInfo(A,C,B)}}var H=W(t.Add,(function(e,t){return e+t}),(function(e,t,a,r){return{real:e+a,imag:t+r}})),w={kernelName:t.Add,backendName:"cpu",kernelFunc:H},C=k(t.Asin,(function(e){return Math.asin(e)})),E={kernelName:t.Asin,backendName:"cpu",kernelFunc:C},B=k(t.Asinh,(function(e){return Math.asinh(e)})),P={kernelName:t.Asinh,backendName:"cpu",kernelFunc:B},O=k(t.Atan,(function(e){return Math.atan(e)})),R={kernelName:t.Atan,backendName:"cpu",kernelFunc:O},q=k(t.Atanh,(function(e){return Math.atanh(e)})),L={kernelName:t.Atanh,backendName:"cpu",kernelFunc:q};function V(e,a,r,n,i,o){for(var s=i.strideHeight,d=i.strideWidth,u=i.dilationHeight,p=i.dilationWidth,l=i.effectiveFilterHeight,f=i.effectiveFilterWidth,c=i.padInfo.top,h=i.padInfo.left,m="max"===o?Number.NEGATIVE_INFINITY:Number.POSITIVE_INFINITY,v=t.buffer(i.outShape,r),y=v.values,k=i.outShape[1]*i.outShape[2]*i.outShape[3],g=i.outShape[2]*i.outShape[3],I=i.outShape[3],b=0;b<i.batchSize;++b)for(var S=b*k,T=b*n[0],N=0;N<i.inChannels;++N)for(var x=0;x<i.outHeight;++x)for(var M=x*s-c,F=Math.max(0,M),A=Math.min(i.inHeight,l+M),D=S+x*g,_=0;_<i.outWidth;++_){for(var z=_*d-h,W=Math.max(0,z),H=Math.min(i.inWidth,f+z),w=m,C=0,E=0,B=F;B<A;B+=u){for(var P=T+B*n[1],O=W;O<H;O+=p){var R=e[P+O*n[2]+N];"max"===o&&R>w?w=R:"avg"===o&&(C+=R,E++)}if(isNaN(w))break}y[D+_*I+N]="avg"===o?C/E:w}return v}function G(e,a,r,n,i,o){void 0===i&&(i=!1),void 0===o&&(o=!1);for(var s=t.buffer(n.outShape,"int32"),d=n.strideHeight,u=n.strideWidth,p=n.dilationHeight,l=n.dilationWidth,f=n.effectiveFilterHeight,c=n.effectiveFilterWidth,h=n.padInfo.top,m=n.padInfo.left,v=t.buffer(a,r,e),y=0;y<n.batchSize;++y)for(var k=0;k<n.inChannels;++k)for(var g=0;g<n.outHeight;++g){for(var I=g*d-h,b=I;b<0;)b+=p;for(var S=Math.min(n.inHeight,f+I),T=0;T<n.outWidth;++T){for(var N=T*u-m,x=N;x<0;)x+=l;for(var M=Math.min(n.inWidth,c+N),F=Number.NEGATIVE_INFINITY,A=-1,D=b;D<S;D+=p)for(var _=D-I,z=x;z<M;z+=l){var W=z-N,H=v.get(y,D,z,k);H>F&&(F=H,A=i?o?((y*n.inHeight+D)*n.inWidth+z)*n.inChannels+k:(D*n.inWidth+z)*n.inChannels+k:_*c+W)}s.set(A,y,g,T,k)}}return s}var U={kernelName:t.AvgPool,backendName:"cpu",kernelFunc:function(e){var a=e.inputs,r=e.backend,n=e.attrs,i=a.x;o(i,"avgPool");var s=n.filterSize,d=n.strides,u=n.pad,p=n.dimRoundingMode;t.util.assert(t.backend_util.eitherStridesOrDilationsAreOne(d,1),(function(){return"Error in avgPool: Either strides or dilations must be 1. Got strides "+d+" and dilations '1'"}));var l,f=t.backend_util.computePool2DInfo(i.shape,s,d,1,u,p);if(1===f.filterWidth&&1===f.filterHeight&&t.util.arraysEqual(f.inShape,f.outShape))l=M({inputs:{x:i},backend:r});else{var c=r.data.get(i.dataId).values,h=t.util.computeStrides(i.shape),m=V(c,i.shape,i.dtype,h,f,"avg");l=r.makeTensorInfo(f.outShape,i.dtype,m.values)}return l}};var j={kernelName:t.AvgPoolBackprop,backendName:"cpu",kernelFunc:function(e){var a=e.inputs,r=e.backend,n=e.attrs,i=a.dy,s=a.input,d=s;o([i,s],"avgPoolBackprop");for(var u=n.filterSize,p=n.strides,l=n.pad,f=t.backend_util.computePool2DInfo(d.shape,u,p,1,l),c=f.strideHeight,h=f.strideWidth,m=f.filterHeight,v=f.filterWidth,y=f.dilationHeight,k=f.dilationWidth,g=f.effectiveFilterHeight,I=f.effectiveFilterWidth,b=I-1-f.padInfo.left,S=g-1-f.padInfo.top,T=t.buffer(d.shape,"float32"),N=1/(m*v),x=r.data.get(i.dataId).values,M=t.buffer(i.shape,"float32",x),F=0;F<f.batchSize;++F)for(var A=0;A<f.inChannels;++A)for(var D=0;D<f.inHeight;++D)for(var _=0;_<f.inWidth;++_){for(var z=D-S,W=_-b,H=0,w=0;w<g;w+=y){var C=(z+w)/c;if(!(C<0||C>=f.outHeight||Math.floor(C)!==C))for(var E=0;E<I;E+=k){var B=(W+E)/h;if(!(B<0||B>=f.outWidth||Math.floor(B)!==B))H+=M.get(F,C,B,A)}}T.set(H*N,F,D,_,A)}return r.makeTensorInfo(T.shape,T.dtype,T.values)}};var Y={kernelName:t.FusedBatchNorm,backendName:"cpu",kernelFunc:function(e){var a=e.inputs,r=e.backend,n=e.attrs,i=a.x,s=a.scale,d=a.offset,u=a.mean,p=a.variance;t.util.assert(u.shape.length===p.shape.length,(function(){return"Batch normalization gradient requires mean and variance to have equal ranks."})),t.util.assert(null==d||u.shape.length===d.shape.length,(function(){return"Batch normalization gradient requires mean and offset to have equal ranks."})),t.util.assert(null==s||u.shape.length===s.shape.length,(function(){return"Batch normalization gradient requires mean and scale to have equal ranks."})),o([i,u,p,s,d],"batchNorm");var l=n.varianceEpsilon;null==l&&(l=.001);for(var f=r.data.get(i.dataId).values,c=r.data.get(u.dataId).values,h=r.data.get(p.dataId).values,m=s?r.data.get(s.dataId).values:new Float32Array([1]),v=d?r.data.get(d.dataId).values:new Float32Array([0]),y=new Float32Array(f.length),k=v.length,g=m.length,I=h.length,b=c.length,S=0,T=0,N=0,x=0,M=0;M<f.length;++M)y[M]=v[S++]+(f[M]-c[T++])*m[N++]/Math.sqrt(h[x++]+l),S>=k&&(S=0),T>=b&&(T=0),N>=g&&(N=0),x>=I&&(x=0);return r.makeTensorInfo(i.shape,i.dtype,y)}},K=k(t.Ceil,(function(e){return Math.ceil(e)})),Z={kernelName:t.Ceil,backendName:"cpu",kernelFunc:K},J=k(t.ClipByValue,(function(e,t){var a=t;return e>a.clipValueMax?a.clipValueMax:e<a.clipValueMin?a.clipValueMin:e})),Q={kernelName:t.ClipByValue,backendName:"cpu",kernelFunc:J};function X(e){var t=e.inputs,a=e.backend,r=t.input,n=a.data.get(r.dataId).complexTensorInfos.imag,i=a.data.get(n.dataId).values;return a.makeTensorInfo(n.shape,n.dtype,i)}var $={kernelName:t.Imag,backendName:"cpu",kernelFunc:X};function ee(e){var a=e.inputs,r=e.backend,n=e.attrs,i=a.x,o=n.shape,s=t.util.sizeFromShape(i.shape),d=t.util.inferFromImplicitShape(o,s),u=t.util.sizeFromShape(d);t.util.assert(s===u,(function(){return"The new shape ("+d+") has "+u+" elements and the old shape ("+i.shape+") has "+s+" elements. The new shape and old shape must have the same number of elements."})),r.incRef(i.dataId);var p=r.data.get(i.dataId);if(null!=p.complexTensorInfos){var l=p.complexTensorInfos.real,f=p.complexTensorInfos.imag;l.shape=d,f.shape=d}return{dataId:i.dataId,shape:d,dtype:i.dtype}}var te={kernelName:t.Reshape,backendName:"cpu",kernelFunc:ee};function ae(e){var a=e.inputs,r=e.backend,n=e.attrs.axis,i=t.util.parseAxisParam(n,a[0].shape)[0],o=t.backend_util.computeOutShape(a.map((function(e){return e.shape})),i);if(0===t.util.sizeFromShape(o))return r.makeTensorInfo(o,a[0].dtype,[]);var s=a.filter((function(e){return t.util.sizeFromShape(e.shape)>0}));if(1===s.length)return s[0];var d=s.map((function(e){return e.shape}));if(t.backend_util.assertParamsConsistent(d,i),"complex64"===s[0].dtype){var u=s.map((function(e){return A({inputs:{input:e},backend:r})})),p=s.map((function(e){return X({inputs:{input:e},backend:r})})),l=ae({inputs:u,backend:r,attrs:{axis:n}}),f=ae({inputs:p,backend:r,attrs:{axis:n}}),c=N({inputs:{real:l,imag:f},backend:r});return u.forEach((function(e){return r.disposeIntermediateTensorInfo(e)})),p.forEach((function(e){return r.disposeIntermediateTensorInfo(e)})),r.disposeIntermediateTensorInfo(l),r.disposeIntermediateTensorInfo(f),c}var h=s.map((function(e){var a=t.util.sizeFromShape(e.shape.slice(i));return ee({inputs:{x:e},backend:r,attrs:{shape:[-1,a]}})}));o=t.backend_util.computeOutShape(h.map((function(e){return e.shape})),1);var m=t.util.getTypedArrayFromDType(s[0].dtype,t.util.sizeFromShape(o));if(1===h[0].shape[0]){var v=0;h.forEach((function(e){var a=r.data.get(e.dataId).values,n=t.util.sizeFromShape(e.shape);m.set(a,v),v+=n}))}else{var y=0;h.forEach((function(e){for(var t=r.data.get(e.dataId).values,a=0,n=0;n<e.shape[0];++n)for(var i=n*o[1]+y,s=0;s<e.shape[1];++s)m[i+s]=t[a++];y+=e.shape[1]}))}var k=t.backend_util.computeOutShape(s.map((function(e){return e.shape})),i),g=r.makeTensorInfo(k,a[0].dtype,m);return h.forEach((function(e){return r.disposeIntermediateTensorInfo(e)})),g}var re={kernelName:t.Concat,backendName:"cpu",kernelFunc:ae},ne=k(t.Cos,(function(e){return Math.cos(e)})),ie={kernelName:t.Cos,backendName:"cpu",kernelFunc:ne},oe=k(t.Cosh,(function(e){return Math.cosh(e)})),se={kernelName:t.Cosh,backendName:"cpu",kernelFunc:oe},de={kernelName:t.Dilation2D,backendName:"cpu",kernelFunc:function(e){for(var a=e.inputs,r=e.backend,n=e.attrs,i=a,o=i.x,s=i.filter,d=n,u=d.strides,p=d.pad,l=d.dilations,f=r,c=f.data.get(o.dataId).values,h=o.shape.length,m=f.data.get(s.dataId).values,v=s.shape.length,y=t.backend_util.computeDilation2DInfo(o.shape,s.shape,u,p,"NHWC",l),k=y.batchSize,g=y.inHeight,I=y.inWidth,b=y.inChannels,S=y.outHeight,T=y.outWidth,N=y.padInfo,x=y.strideHeight,M=y.strideWidth,F=y.filterHeight,A=y.filterWidth,D=y.dilationHeight,_=y.dilationWidth,z=y.outShape,W=t.util.sizeFromShape(z),H=z.length,w=t.util.getArrayFromDType(o.dtype,W),C=0;C<k;++C)for(var E=0;E<S;++E)for(var B=E*x-N.top,P=0;P<T;++P)for(var O=P*M-N.left,R=0;R<b;++R){for(var q=Number.MIN_SAFE_INTEGER,L=0;L<F;++L){var V=B+L*D;if(V>=0&&V<g)for(var G=0;G<A;++G){var U=O+G*_;if(U>=0&&U<I){var j=t.util.locToIndex([C,V,U,R],h,t.util.computeStrides(o.shape)),Y=t.util.locToIndex([L,G,R],v,t.util.computeStrides(s.shape)),K=c[j]+m[Y];K>q&&(q=K)}}}w[t.util.locToIndex([C,E,P,R],H,t.util.computeStrides(z))]=q}return{dataId:f.write(t.util.toTypedArray(w,o.dtype),z,o.dtype),shape:z,dtype:o.dtype}}},ue={kernelName:t.Dilation2DBackpropFilter,backendName:"cpu",kernelFunc:function(e){var a=e.inputs,r=e.backend,n=e.attrs,i=a,o=i.x,s=i.filter,d=i.dy,u=n,p=u.strides,l=u.pad,f=u.dilations,c=r,h=t.util.toNestedArray(o.shape,c.data.get(o.dataId).values),m=t.util.toNestedArray(s.shape,c.data.get(s.dataId).values),v=t.backend_util.computeDilation2DInfo(o.shape,s.shape,p,l,"NHWC",f),y=v.batchSize,k=v.inHeight,g=v.inWidth,I=v.inChannels,b=v.outHeight,S=v.outWidth,T=v.padInfo,N=v.strideHeight,x=v.strideWidth,M=v.filterHeight,F=v.filterWidth,A=v.dilationHeight,D=v.dilationWidth,_=v.outShape;t.util.assert(d.rank===_.length,(function(){return"Error in "+t.Dilation2DBackpropFilter+", dy must have the same rank as output "+_.length+", but got "+d.rank}));for(var z=t.util.toNestedArray(_,c.data.get(d.dataId).values),W=t.util.makeZerosNestedTypedArray(s.shape,s.dtype),H=0;H<y;++H)for(var w=0;w<b;++w)for(var C=w*N-T.top,E=0;E<S;++E)for(var B=E*x-T.left,P=0;P<I;++P){for(var O=Number.MIN_SAFE_INTEGER,R=0,q=0,L=0;L<M;++L){var V=C+L*A;if(V>=0&&V<k)for(var G=0;G<F;++G){var U=B+G*D;if(U>=0&&U<g){var j=h[H][V][U][P]+m[L][G][P];j>O&&(O=j,R=L,q=G)}}}W[R][q][P]+=z[H][w][E][P]}return{dataId:c.write(t.util.toTypedArray(W,o.dtype),s.shape,s.dtype),shape:s.shape,dtype:s.dtype}}},pe={kernelName:t.Dilation2DBackpropInput,backendName:"cpu",kernelFunc:function(e){var a=e.inputs,r=e.backend,n=e.attrs,i=a,o=i.x,s=i.filter,d=i.dy,u=n,p=u.strides,l=u.pad,f=u.dilations,c=r,h=t.util.toNestedArray(o.shape,c.data.get(o.dataId).values),m=t.util.toNestedArray(s.shape,c.data.get(s.dataId).values),v=t.backend_util.computeDilation2DInfo(o.shape,s.shape,p,l,"NHWC",f),y=v.batchSize,k=v.inHeight,g=v.inWidth,I=v.inChannels,b=v.outHeight,S=v.outWidth,T=v.padInfo,N=v.strideHeight,x=v.strideWidth,M=v.filterHeight,F=v.filterWidth,A=v.dilationHeight,D=v.dilationWidth,_=v.outShape;t.util.assert(d.rank===_.length,(function(){return"Error in "+t.Dilation2DBackpropInput+", dy must have the same rank as output "+_.length+", but got "+d.rank}));for(var z=t.util.toNestedArray(_,c.data.get(d.dataId).values),W=t.util.makeZerosNestedTypedArray(o.shape,o.dtype),H=0;H<y;++H)for(var w=0;w<b;++w)for(var C=w*N-T.top,E=0;E<S;++E)for(var B=E*x-T.left,P=0;P<I;++P){for(var O=Number.MIN_SAFE_INTEGER,R=C<0?0:C,q=B<0?0:B,L=0;L<M;++L){var V=C+L*A;if(V>=0&&V<k)for(var G=0;G<F;++G){var U=B+G*D;if(U>=0&&U<g){var j=h[H][V][U][P]+m[L][G][P];j>O&&(O=j,R=V,q=U)}}}W[H][R][q][P]+=z[H][w][E][P]}return{dataId:c.write(t.util.toTypedArray(W,o.dtype),o.shape,o.dtype),shape:o.shape,dtype:o.dtype}}},le=W(t.Div,(function(e,t){return e/t})),fe={kernelName:t.Div,backendName:"cpu",kernelFunc:le},ce=k(t.Elu,(function(e){return e>=0?e:Math.exp(e)-1})),he={kernelName:t.Elu,backendName:"cpu",kernelFunc:ce},me=t.backend_util.ERF_P,ve=t.backend_util.ERF_A1,ye=t.backend_util.ERF_A2,ke=t.backend_util.ERF_A3,ge=t.backend_util.ERF_A4,Ie=t.backend_util.ERF_A5,be=k(t.Erf,(function(e){var t=Math.sign(e),a=Math.abs(e),r=1/(1+me*a);return t*(1-((((Ie*r+ge)*r+ke)*r+ye)*r+ve)*r*Math.exp(-a*a))})),Se={kernelName:t.Erf,backendName:"cpu",kernelFunc:be},Te=k(t.Exp,(function(e){return Math.exp(e)})),Ne={kernelName:t.Exp,backendName:"cpu",kernelFunc:Te},xe=k(t.Expm1,(function(e){return Math.expm1(e)})),Me={kernelName:t.Expm1,backendName:"cpu",kernelFunc:xe},Fe=W(t.Multiply,(function(e,t){return e*t}),(function(e,t,a,r){return{real:e*a-t*r,imag:e*r+t*a}})),Ae={kernelName:t.Multiply,backendName:"cpu",kernelFunc:Fe};function De(e){var a=e.inputs,r=e.backend,n=e.attrs,i=a.x,s=n.begin,d=n.size;o(i,"slice");var u=i.shape.length,p=t.util.computeStrides(i.shape),l=t.slice_util.parseSliceParams(i,s,d),f=l[0],c=l[1];t.slice_util.assertParamsValid(i,f,c);var h=t.slice_util.isSliceContinous(i.shape,f,c),m=r.data.get(i.dataId).values,v=t.util.sizeFromShape(c);if(h){var y=t.slice_util.computeFlatOffset(f,p),k=m.subarray(y,y+v);return r.makeTensorInfo(c,i.dtype,k)}for(var g=t.util.getTypedArrayFromDType(i.dtype,v),I=0;I<v;++I){var b=c.length,S=t.util.computeStrides(c),T=t.util.indexToLoc(I,b,S).map((function(e,t){return e+f[t]})),N=t.util.locToIndex(T,u,p);g[I]=m[N]}return r.makeTensorInfo(c,i.dtype,g)}var _e={kernelName:t.Slice,backendName:"cpu",kernelFunc:De},ze=W(t.Sub,(function(e,t){return e-t}),(function(e,t,a,r){return{real:e-a,imag:t-r}})),We={kernelName:t.Sub,backendName:"cpu",kernelFunc:ze};function He(e,a,r){for(var n=e.shape,i=n[0],o=n[1],s=r.data.get(e.dataId),d=s.complexTensorInfos.real,u=s.complexTensorInfos.imag,p=[i,o],l=t.util.sizeFromShape(p),f=t.util.getTypedArrayFromDType("float32",l),c=t.util.getTypedArrayFromDType("float32",l),h=0;h<i;h++){for(var m=De({inputs:{x:d},backend:r,attrs:{begin:[h,0],size:[1,o]}}),v=De({inputs:{x:u},backend:r,attrs:{begin:[h,0],size:[1,o]}}),y=N({inputs:{real:m,imag:v},backend:r}),k=we(y,a,r),g=k.real,I=k.imag,b=t.backend_util.mergeRealAndImagArrays(g,I),S=0;S<o;S++){var T=t.backend_util.getComplexWithIndex(b,S);f[h*o+S]=T.real,c[h*o+S]=T.imag}r.disposeIntermediateTensorInfo(m),r.disposeIntermediateTensorInfo(v),r.disposeIntermediateTensorInfo(y)}var x=r.makeTensorInfo(p,"float32",f),M=r.makeTensorInfo(p,"float32",c),F=N({inputs:{real:x,imag:M},backend:r});return r.disposeIntermediateTensorInfo(x),r.disposeIntermediateTensorInfo(M),F}function we(e,a,r){var n=t.util.sizeFromShape(e.shape),i=r.data.get(e.dataId),o=r.data.get(i.complexTensorInfos.real.dataId).values,s=r.data.get(i.complexTensorInfos.imag.dataId).values;if(0==((k=n)&k-1)){var d=function e(a,r,n,i,o){if(1===n)return{real:a,imag:r};var s=t.backend_util.mergeRealAndImagArrays(a,r),d=n/2,u=t.backend_util.complexWithEvenIndex(s),p=u.real,l=u.imag,f=[p.length],c=o.makeTensorInfo(f,"float32",p),h=o.makeTensorInfo(f,"float32",l),m=N({inputs:{real:c,imag:h},backend:o}),v=t.backend_util.complexWithOddIndex(s),y=v.real,k=v.imag,g=[y.length],I=o.makeTensorInfo(g,"float32",y),b=o.makeTensorInfo(g,"float32",k),S=N({inputs:{real:I,imag:b},backend:o}),T=e(p,l,d,i,o),x=T.real,M=T.imag,F=[x.length],D=o.makeTensorInfo(F,"float32",x),_=o.makeTensorInfo(F,"float32",M),z=N({inputs:{real:D,imag:_},backend:o}),W=e(y,k,d,i,o),w=W.real,C=W.imag,E=[w.length],B=o.makeTensorInfo(E,"float32",w),P=o.makeTensorInfo(E,"float32",C),O=N({inputs:{real:B,imag:P},backend:o}),R=t.backend_util.exponents(n,i),q=[R.real.length],L=o.makeTensorInfo(q,"float32",R.real),V=o.makeTensorInfo(q,"float32",R.imag),G=N({inputs:{real:L,imag:V},backend:o}),U=Fe({inputs:{a:G,b:O},backend:o}),j=H({inputs:{a:z,b:U},backend:o}),Y=ze({inputs:{a:z,b:U},backend:o}),K=A({inputs:{input:j},backend:o}),Z=A({inputs:{input:Y},backend:o}),J=X({inputs:{input:j},backend:o}),Q=X({inputs:{input:Y},backend:o}),$=ae({inputs:[K,Z],backend:o,attrs:{axis:0}}),ee=ae({inputs:[J,Q],backend:o,attrs:{axis:0}}),te=o.data.get($.dataId).values,re=o.data.get(ee.dataId).values;return o.disposeIntermediateTensorInfo(c),o.disposeIntermediateTensorInfo(h),o.disposeIntermediateTensorInfo(m),o.disposeIntermediateTensorInfo(I),o.disposeIntermediateTensorInfo(b),o.disposeIntermediateTensorInfo(S),o.disposeIntermediateTensorInfo(D),o.disposeIntermediateTensorInfo(_),o.disposeIntermediateTensorInfo(z),o.disposeIntermediateTensorInfo(B),o.disposeIntermediateTensorInfo(P),o.disposeIntermediateTensorInfo(O),o.disposeIntermediateTensorInfo(L),o.disposeIntermediateTensorInfo(V),o.disposeIntermediateTensorInfo(G),o.disposeIntermediateTensorInfo(U),o.disposeIntermediateTensorInfo(j),o.disposeIntermediateTensorInfo(Y),o.disposeIntermediateTensorInfo(K),o.disposeIntermediateTensorInfo(J),o.disposeIntermediateTensorInfo(Z),o.disposeIntermediateTensorInfo(Q),o.disposeIntermediateTensorInfo($),o.disposeIntermediateTensorInfo(ee),{real:te,imag:re}}(o,s,n,a,r),u=[e.shape[0],e.shape[1]];if(a){var p=r.makeTensorInfo(u,"float32",d.real),l=r.makeTensorInfo(u,"float32",d.imag),f=r.makeTensorInfo([],"float32",t.util.createScalarValue(n,"float32")),c=M({inputs:{x:f},backend:r}),h=fe.kernelFunc({inputs:{a:p,b:f},backend:r}),m=fe.kernelFunc({inputs:{a:l,b:c},backend:r}),v=r.data.get(h.dataId).values,y=r.data.get(m.dataId).values;return r.disposeIntermediateTensorInfo(p),r.disposeIntermediateTensorInfo(l),r.disposeIntermediateTensorInfo(f),r.disposeIntermediateTensorInfo(c),r.disposeIntermediateTensorInfo(h),r.disposeIntermediateTensorInfo(m),{real:v,imag:y}}return d}var k,g=function(e,a,r){for(var n=new Float32Array(2*a),i=0;i<a;i++){for(var o=0,s=0,d=0;d<a;d++){var u=t.backend_util.exponent(i*d,a,r),p=t.backend_util.getComplexWithIndex(e,d);o+=p.real*u.real-p.imag*u.imag,s+=p.real*u.imag+p.imag*u.real}r&&(o/=a,s/=a),t.backend_util.assignToTypedArray(n,o,s,i)}return n}(t.backend_util.mergeRealAndImagArrays(o,s),n,a);return t.backend_util.splitRealAndImagArrays(g)}var Ce={kernelName:t.FFT,backendName:"cpu",kernelFunc:function(e){var a=e.inputs,r=e.backend,n=a.input,i=t.util.sizeFromShape(n.shape),o=n.shape[n.shape.length-1],s=ee({inputs:{x:n},backend:r,attrs:{shape:[i/o,o]}}),d=He(s,!1,r),u=ee({inputs:{x:d},backend:r,attrs:{shape:n.shape}});return r.disposeIntermediateTensorInfo(s),r.disposeIntermediateTensorInfo(d),u}},Ee={kernelName:t.FlipLeftRight,backendName:"cpu",kernelFunc:function(e){for(var a=e.inputs,r=(e.attrs,e.backend),n=a.image,i=r,o=t.util.getTypedArrayFromDType(n.dtype,t.util.sizeFromShape(n.shape)),s=n.shape,d=s[0],u=s[1],p=s[2],l=s[3],f=i.data.get(n.dataId).values,c=0;c<d;c++)for(var h=c*p*u*l,m=0;m<u;m++)for(var v=m*(p*l),y=0;y<p;y++)for(var k=y*l,g=0;g<l;g++){var I=[d,m,y,g][2],b=Math.round(p-I),S=h+v+k+g,T=f[S];if(b>=0&&b<p)T=f[h+v+b*l+g];o[S]=T}return{dataId:i.write(o,n.shape,n.dtype),shape:n.shape,dtype:n.dtype}}},Be=k(t.Floor,(function(e){return Math.floor(e)})),Pe={kernelName:t.Floor,backendName:"cpu",kernelFunc:Be};var Oe={kernelName:t.IFFT,backendName:"cpu",kernelFunc:function(e){var a=e.inputs,r=e.backend,n=a.input,i=t.util.sizeFromShape(n.shape),o=n.shape[n.shape.length-1],s=ee({inputs:{x:n},backend:r,attrs:{shape:[i/o,o]}}),d=He(s,!0,r),u=ee({inputs:{x:d},backend:r,attrs:{shape:n.shape}});return r.disposeIntermediateTensorInfo(s),r.disposeIntermediateTensorInfo(d),u}},Re=k(t.IsFinite,(function(e){return Number.isFinite(e)?1:0}),"bool"),qe={kernelName:t.IsFinite,backendName:"cpu",kernelFunc:Re},Le=k(t.IsInf,(function(e){return Math.abs(e)===1/0?1:0}),"bool"),Ve={kernelName:t.IsInf,backendName:"cpu",kernelFunc:Le},Ge=k(t.IsNan,(function(e){return Number.isNaN(e)?1:0}),"bool"),Ue={kernelName:t.IsNan,backendName:"cpu",kernelFunc:Ge},je=k(t.Log,(function(e){return Math.log(e)})),Ye={kernelName:t.Log,backendName:"cpu",kernelFunc:je},Ke=k(t.Log1p,(function(e){return Math.log1p(e)})),Ze={kernelName:t.Log1p,backendName:"cpu",kernelFunc:Ke},Je=k(t.LogicalNot,(function(e){return e?0:1}),"bool"),Qe={kernelName:t.LogicalNot,backendName:"cpu",kernelFunc:Je},Xe={kernelName:t.Max,backendName:"cpu",kernelFunc:function(e){var a=e.inputs,r=e.attrs,n=e.backend,i=a.x,s=r,d=s.reductionIndices,u=s.keepDims,p=n,l=i.shape,f=l.length,c=t.util.parseAxisParam(d,l),v=c,y=t.backend_util.getAxesPermutation(v,f),k=p.data.get(i.dataId).values;if(null!=y){for(var g=new Array(f),I=0;I<g.length;I++)g[I]=l[y[I]];k=m(k,l,i.dtype,y,g),v=t.backend_util.getInnerMostAxes(v.length,f),l=g}o(i,"max"),t.backend_util.assertAxesAreInnerMostDims("max",v,f);var b=t.backend_util.computeOutAndReduceShapes(l,v),S=b[0],T=b[1],N=h(k,t.util.sizeFromShape(T),S,i.dtype),x=p.write(N,S,i.dtype),M=S;u&&(M=g=t.backend_util.expandShapeToKeepDim(S,c));return{dataId:x,shape:M,dtype:i.dtype}}};var $e={kernelName:t.MaxPool,backendName:"cpu",kernelFunc:function(e){var a=e.inputs,r=e.backend,n=e.attrs,i=a.x;o(i,"maxPool");var s=n.filterSize,d=n.strides,u=n.pad,p=n.dimRoundingMode;t.util.assert(t.backend_util.eitherStridesOrDilationsAreOne(d,1),(function(){return"Error in maxPool: Either strides or dilations must be 1. Got strides "+d+" and dilations '1'"}));var l,f=t.backend_util.computePool2DInfo(i.shape,s,d,1,u,p);if(1===f.filterWidth&&1===f.filterHeight&&t.util.arraysEqual(f.inShape,f.outShape))l=M({inputs:{x:i},backend:r});else{var c=r.data.get(i.dataId).values,h=t.util.computeStrides(i.shape),m=V(c,i.shape,i.dtype,h,f,"max");l=r.makeTensorInfo(f.outShape,i.dtype,m.values)}return l}};var et={kernelName:t.MaxPoolBackprop,backendName:"cpu",kernelFunc:function(e){var a=e.inputs,r=e.backend,n=e.attrs,i=a.dy,s=a.input,d=s;o([s,a.output],"maxPoolBackprop");for(var u=n.filterSize,p=n.strides,l=n.pad,f=n.dimRoundingMode,c=t.backend_util.computePool2DInfo(d.shape,u,p,1,l,f),h=r.data.get(d.dataId).values,m=t.buffer(c.outShape,d.dtype,G(h,d.shape,d.dtype,c).values),v=c.strideHeight,y=c.strideWidth,k=c.dilationHeight,g=c.dilationWidth,I=c.effectiveFilterHeight,b=c.effectiveFilterWidth,S=b-1-c.padInfo.left,T=I-1-c.padInfo.top,N=t.buffer(d.shape,"float32"),x=r.data.get(i.dataId).values,M=t.buffer(i.shape,"float32",x),F=0;F<c.batchSize;++F)for(var A=0;A<c.inChannels;++A)for(var D=0;D<c.inHeight;++D)for(var _=0;_<c.inWidth;++_){for(var z=D-T,W=_-S,H=0,w=0;w<I;w+=k){var C=(z+w)/v;if(!(C<0||C>=c.outHeight||Math.floor(C)!==C))for(var E=0;E<b;E+=g){var B=(W+E)/y;if(!(B<0||B>=c.outWidth||Math.floor(B)!==B)){var P=I*b-1-m.get(F,C,B,A)===w*b+E?1:0;if(0!==P)H+=M.get(F,C,B,A)*P}}}N.set(H,F,D,_,A)}return r.makeTensorInfo(N.shape,N.dtype,N.values)}};var tt={kernelName:t.MaxPoolWithArgmax,backendName:"cpu",kernelFunc:function(e){var a=e.inputs,r=e.attrs,n=e.backend,i=a.x,s=r,d=s.filterSize,u=s.strides,p=s.pad,l=s.includeBatchInIndex,f=n;o(i,"MaxPoolWithArgmax");var c=f.data.get(i.dataId).values,h=t.backend_util.computePool2DInfo(i.shape,d,u,[1,1],p),m=function(e,a,r,n,i){var o=V(e,0,r,t.util.computeStrides(a),i,"max"),s=G(e,a,r,i,!0,n);return[o.values,s.values]}(c,i.shape,i.dtype,l,h),v=m[0],y=m[1],k=f.write(v,h.outShape,i.dtype),g=f.write(y,h.outShape,i.dtype);return[{dataId:k,shape:h.outShape,dtype:i.dtype},{dataId:g,shape:h.outShape,dtype:"int32"}]}},at=t.kernel_impls.nonMaxSuppressionV4Impl,rt={kernelName:t.NonMaxSuppressionV4,backendName:"cpu",kernelFunc:function(e){var t=e.inputs,a=e.backend,r=e.attrs,n=t,i=n.boxes,s=n.scores,d=r,u=d.maxOutputSize,p=d.iouThreshold,l=d.scoreThreshold,f=d.padToMaxOutputSize,c=a;o(i,"NonMaxSuppressionPadded");var h=c.data.get(i.dataId).values,m=c.data.get(s.dataId).values,v=at(h,m,u,p,l,f);return[v.selectedIndices,v.validOutputs]}},nt=t.kernel_impls.nonMaxSuppressionV5Impl,it={kernelName:t.NonMaxSuppressionV5,backendName:"cpu",kernelFunc:function(e){var t=e.inputs,a=e.backend,r=e.attrs,n=t,i=n.boxes,s=n.scores,d=r,u=d.maxOutputSize,p=d.iouThreshold,l=d.scoreThreshold,f=d.softNmsSigma,c=a;o(i,"NonMaxSuppressionWithScore");var h=c.data.get(i.dataId).values,m=c.data.get(s.dataId).values,v=nt(h,m,u,p,l,f);return[v.selectedIndices,v.selectedScores]}},ot=W(t.NotEqual,(function(e,t){return e!==t?1:0}),null,"bool"),st={kernelName:t.NotEqual,backendName:"cpu",kernelFunc:ot};var dt={kernelName:t.PadV2,backendName:"cpu",kernelFunc:function(e){var a=e.inputs,r=e.backend,n=e.attrs,i=a.x,s=n.paddings,d=n.constantValue;o(i,"pad");var u=s.map((function(e,t){return e[0]+i.shape[t]+e[1]})),p=s.map((function(e){return e[0]})),l=r.data.get(i.dataId).values,f=t.util.sizeFromShape(i.shape),c=i.shape.length,h=t.util.computeStrides(i.shape),m=t.util.sizeFromShape(u),v=u.length,y=t.util.computeStrides(u),k=t.util.getTypedArrayFromDType(i.dtype,m);0!==d&&k.fill(d);for(var g=0;g<f;g++){var I=t.util.indexToLoc(g,c,h).map((function(e,t){return e+p[t]}));k[t.util.locToIndex(I,v,y)]=l[g]}return{dataId:r.write(k,u,i.dtype),shape:u,dtype:i.dtype}}},ut=k(t.Reciprocal,(function(e){return 1/e})),pt={kernelName:t.Reciprocal,backendName:"cpu",kernelFunc:ut},lt={kernelName:t.RotateWithOffset,backendName:"cpu",kernelFunc:function(e){for(var a=e.inputs,r=e.attrs,n=e.backend,i=a.image,o=r,s=o.radians,d=o.fillValue,u=o.center,p=n,l=t.util.getTypedArrayFromDType(i.dtype,t.util.sizeFromShape(i.shape)),f=i.shape,c=f[0],h=f[1],m=f[2],v=f[3],y=t.backend_util.getImageCenter(u,h,m),k=y[0],g=y[1],I=Math.sin(s),b=Math.cos(s),S=p.data.get(i.dataId).values,T=0;T<c;T++)for(var N=T*m*h*v,x=0;x<h;x++)for(var M=x*(m*v),F=0;F<m;F++)for(var A=F*v,D=0;D<v;D++){var _=[c,x,F,D],z=_[2],W=_[1],H=(z-k)*b-(W-g)*I,w=(z-k)*I+(W-g)*b;H=Math.round(H+k),w=Math.round(w+g);var C=d;if("number"!=typeof d&&(C=3===D?255:d[D]),H>=0&&H<m&&w>=0&&w<h)C=S[N+w*(m*v)+H*v+D];l[N+M+A+D]=C}return{dataId:p.write(l,i.shape,i.dtype),shape:i.shape,dtype:i.dtype}}},ft=k(t.Round,(function(e){var t=Math.floor(e);return e-t<.5?Math.floor(e):e-t>.5?Math.ceil(e):t%2==0?t:t+1})),ct={kernelName:t.Round,backendName:"cpu",kernelFunc:ft},ht=k(t.Rsqrt,(function(e){return 1/Math.sqrt(e)})),mt={kernelName:t.Rsqrt,backendName:"cpu",kernelFunc:ht},vt=t.backend_util.SELU_SCALEALPHA,yt=t.backend_util.SELU_SCALE,kt=k(t.Selu,(function(e){return e>=0?yt*e:vt*(Math.exp(e)-1)})),gt={kernelName:t.Selu,backendName:"cpu",kernelFunc:kt},It=k(t.Sigmoid,(function(e){return 1/(1+Math.exp(-e))})),bt={kernelName:t.Sigmoid,backendName:"cpu",kernelFunc:It},St=k(t.Sign,(function(e){return e<0?-1:e>0?1:0})),Tt={kernelName:t.Sign,backendName:"cpu",kernelFunc:St},Nt=k(t.Sin,(function(e){return Math.sin(e)})),xt={kernelName:t.Sin,backendName:"cpu",kernelFunc:Nt},Mt=k(t.Sinh,(function(e){return Math.sinh(e)})),Ft={kernelName:t.Sinh,backendName:"cpu",kernelFunc:Mt},At=Math.log(1.1920928955078125e-7)+2,Dt=k(t.Softplus,(function(e){var t=e>-At,a=e<At,r=Math.exp(e);return a?r:t?e:Math.log(1+r)})),_t={kernelName:t.Softplus,backendName:"cpu",kernelFunc:Dt};function zt(e){var t=e.inputs,a=e.attrs,r=e.backend,n=t.x,i=a.perm;o(n,"transpose");for(var s=n.shape.length,d=new Array(s),u=0;u<d.length;u++)d[u]=n.shape[i[u]];var p=m(r.data.get(n.dataId).values,n.shape,n.dtype,i,d);return{dataId:r.write(p,d,n.dtype),shape:d,dtype:n.dtype}}var Wt={kernelName:t.Transpose,backendName:"cpu",kernelFunc:zt};for(var Ht={kernelName:t.SpaceToBatchND,backendName:"cpu",kernelFunc:function(e){var a=e.inputs,r=e.backend,n=e.attrs,i=a.x,s=n.blockShape,d=n.paddings;o([i],"spaceToBatchND");var u=t.util.sizeFromShape(s),p=[[0,0]];p.push.apply(p,d);for(var l=1+s.length;l<i.shape.length;++l)p.push([0,0]);var f=dt.kernelFunc({inputs:{x:i},backend:r,attrs:{paddings:p,constantValue:0}}),c=t.backend_util.getReshaped(f.shape,s,u,!1),h=t.backend_util.getPermuted(c.length,s.length,!1),m=t.backend_util.getReshapedPermuted(f.shape,s,u,!1),v=ee({inputs:{x:f},backend:r,attrs:{shape:c}}),y=zt({inputs:{x:v},backend:r,attrs:{perm:h}}),k=ee({inputs:{x:y},backend:r,attrs:{shape:m}});return r.disposeIntermediateTensorInfo(f),r.disposeIntermediateTensorInfo(v),r.disposeIntermediateTensorInfo(y),k}},wt=k(t.Sqrt,(function(e){return Math.sqrt(e)})),Ct={kernelName:t.Sqrt,backendName:"cpu",kernelFunc:wt},Et={kernelName:t.Square,backendName:"cpu",kernelFunc:function(e){var t=e.inputs,a=e.backend,r=t.x,n=a;o(r,"square");for(var i=n.data.get(r.dataId).values,s=new Float32Array(i.length),d=0;d<i.length;++d){var u=i[d];s[d]=u*u}return{dataId:n.write(s,r.shape,r.dtype),shape:r.shape,dtype:r.dtype}}},Bt=W(t.SquaredDifference,(function(e,t){var a=e-t;return a*a})),Pt={kernelName:t.SquaredDifference,backendName:"cpu",kernelFunc:Bt},Ot=k(t.Step,(function(e,t){var a=t;return isNaN(e)?NaN:e>0?1:a.alpha})),Rt={kernelName:t.Step,backendName:"cpu",kernelFunc:Ot},qt=k(t.Tan,(function(e){return Math.tan(e)})),Lt={kernelName:t.Tan,backendName:"cpu",kernelFunc:qt},Vt=k(t.Tanh,(function(e){return Math.tanh(e)})),Gt={kernelName:t.Tanh,backendName:"cpu",kernelFunc:Vt},Ut=0,jt=[y,I,S,w,E,P,R,L,U,j,Y,z,Z,Q,x,re,ie,se,de,pe,ue,fe,he,Se,Ne,Me,Ce,Ee,Pe,F,Oe,$,qe,Ve,Ue,Ye,Ze,Qe,$e,et,tt,Xe,Ae,rt,it,st,dt,D,pt,te,lt,ct,mt,gt,bt,Tt,xt,Ft,_e,_t,Ht,Ct,Et,Pt,Rt,We,Lt,Gt,Wt];Ut<jt.length;Ut++){var Yt=jt[Ut];t.registerKernel(Yt)}e.MathBackendCPU=c,e.shared=v,e.version_cpu="2.5.0",Object.defineProperty(e,"__esModule",{value:!0})}));
//# sourceMappingURL=tf-backend-cpu.min.js.map
